#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"


void jacam(double lambda, int k,int ll, double *y) 
/*
* JACAM -- evaluates kk-th column of Jacobian at given point
*           with respect to Am. or w.r.t. Am_kl 
* Input parameters: k, ll -- the index of the element of Am
* Output parameters: y - evaluated function 
*/
{
      int ind;
      register int i,j;
      double eps = -1.0;
 
       setmat(0.0,att,nt,nt); /* Derivative of A tilde */
       att[n+k][n+ll] = 1.0;
         
      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Q^(j)*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp1,ttemp2,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rt,ttemp2,nt,nt,nt); /* Compute P^(j) */
      scmat(gaman2,ttemp2,ttemp2,nt,nt);
      addmat1(att,ttemp2,ttemp3,nt,nt);
      mulmat2(ttemp3,pt,ttemp1,nt,nt,nt);
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp2,ttemp1,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
 
/* Compute derivatives of H_Am */

      mulmat2(ptd12,qt12,temp1,nm,nm,n); 
      mulmat2(pt12,qtd12,temp2,nm,nm,n);  
      addmat1(temp1,temp2,ttemp3,nm,nm);
      mulmat2(ptd2,qt2,temp1,nm,nm,nm);
      mulmat2(pt2,qtd2,temp2,nm,nm,nm);  
      addmat1(temp1,temp2,temp2,nm,nm);
      addmat1(ttemp3,temp2,ttemp1,nm,nm); 

       j = 0;
       for(i=0;i<nm/2;i++){
          *(y+j) = ttemp1[2*i+1][2*i];
          *(y+j+1) = ttemp1[2*i+1][2*i+1];
          j += 2;
        } 
        *(y + nm -1) = ttemp1[nm-1][nm-1];
 
/* Compute derivatives of H_Bm */

 	mulmat1(ptd2,bmv,temp1,nm,m,nm);
        mulmat2(ptd12,bv,temp2,nm,m,n);
        addmat1(temp1,temp2,temp3,nm,m);
        toarray(nm,m,temp3,y+nm);
 
/* Compute derivatives of H_Cm */
/* Original terms              */ 
       if( l != 1){
        mulmat1(rcm,qtd2,temp2,l,nm,nm);
 	mulmat1(rc,qtd12,temp3,l,nm,n);
 	addmat3(temp2,temp3,temp1,l,nm);

        hcmterms( );  
 	addmat1(temp1,temp3,temp2,l,nm);

        k = nm + nm*m;
        for(i=1;i<l;i++)
          for(j=0;j<nm;j++){
            *(y+k) = temp2[i][j];    
            k++;
         }
       }
} 
