#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void jaccm(double lambda, int k,int ll, double *y)
/* 
* JACCM evaluates kk-th column of Jacobian at given point w.r.t. Cm.
* Input parameters: k, ll -- the index of the element of Cm 
* Output parameters: * y - evaluated function
*/
{
      int ind;
      int i,j;
      double eps = -1.0;

       for (i=0;i<n;i++) /* Derivative of R tilde          */  
	  for(j=0;j<n;j++) rtt[i][j]=0.0; 
       
       setmat(0.0,temp1,n,nm) ; /* C^T R E^(k,l)--12 block of Rt^(j) */  
       for(j=0;j<n;j++) temp1[j][ll] = - rc[k][j];
       for(i=0;i<n;i++) for(j=n;j<nt;j++) 
           {rtt[i][j]= temp1[i][j-n]; rtt[j][i]= rtt[i][j];}

       setmat(0.0,temp1,nm,nm); /* Cm^tRE^(k,ll)+E^(ll,k) R Cm  */
       for(j=0;j<nm;j++) temp1[j][ll] = rcm[k][j];
       trans(temp1,temp2,nm,nm);
       addmat1(temp1,temp2,ttemp1,nm,nm);
       for(i=n;i<nt;i++) /*  22 block of Rt^(j) */
	  for(j=n;j<nt;j++) rtt[i][j]=ttemp1[i-n][j-n];

      scmat(gaman2,rtt,ttemp2,nt,nt); /* Q^(j) */
      mulmat1(ttemp2,qt,ttemp1,nt,nt,nt);
      mulmat1(qt,ttemp1,ttemp2,nt,nt,nt);
      scmat(-1.0,ttemp2,ttemp1,nt,nt);
      tmparray(ttemp1,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rt,ttemp2,nt,nt,nt); /* Compute P^(j) */
      mulmat1(qt,rtt,ttemp1,nt,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      scmat(gaman2,ttemp3,ttemp1,nt,nt);
      mulmat2(ttemp1,pt,ttemp2,nt,nt,nt);
      trans(ttemp2,ttemp3,nt,nt);
      addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
      addmat4(rtt,ttemp1,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
         
/* Compute derivative of H_Am  */
 
      mulmat2(ptd12,qt12,temp1,nm,nm,n);
      mulmat2(pt12,qtd12,temp2,nm,nm,n);  
      addmat1(temp1,temp2,ttemp2,nm,nm);
      mulmat2(ptd2,qt2,temp1,nm,nm,nm);
      mulmat2(pt2,qtd2,temp2,nm,nm,nm);  
      addmat1(temp1,temp2,temp3,nm,nm);
      addmat1(ttemp2,temp3,temp1,nm,nm); 
 
       j = 0;
       for(i=0;i<nm/2;i++){
          *(y+j) = temp1[2*i+1][2*i];
          *(y+j+1) = temp1[2*i+1][2*i+1];
          j += 2;
        } 
        *(y + nm -1) = temp1[nm-1][nm-1];

/* Compute derivative of H_Bm  */
 
      mulmat2(ptd12,bv,temp2,nm,m,n);
      mulmat1(ptd2,bmv,temp1,nm,m,nm);
      addmat1(temp1,temp2,temp3,nm,m);
      toarray(nm,m,temp3,y+nm);
 
/* Compute derivative of H_Cm       */
/* Originial terms                  */ 
       mulmat1(rcm,qtd2,temp2,l,nm,nm);
       mulmat1(rc,qtd12,temp3,l,nm,n);
       addmat3(temp2,temp3,temp1,l,nm);

       eps = 0.5 * gaman2;
       scmat(eps,temp4,temp3,nm,nm);
       addmat1(qt2,temp3,ttemp3,nm,nm);
       setmat(0.00,temp2,l,nm);
       for(j=0;j<nm;j++) temp2[k][j] = ttemp3[ll][j];
       mulmat1(r,temp2,temp3,l,nm,l);
       addmat1(temp1,temp3,temp1,l,nm);
       
       hcmterms();
       addmat1(temp1,temp3,temp2,l,nm);

        k = nm + nm*m;
        for(i=1;i<l;i++)
          for(j=0;j<nm;j++){
            *(y+k) = temp2[i][j];    
            k++;
         }
}
