#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

extern void riccnd(), atxpxa();

void jaclam(double lambda, double *y)
/*
JACLAM evaluates 1-th column of Jacobian (w.r.t Lambda) at given point.
* Input parameters: lambda 
* Output parameters: y - evaluated function
*/
{
      int ind;
      register int i,j, k;
      double eps;
 
/* Compute the last three terms of  Hcm'  in temp3 */
/* temp4 = Z1^t Q12 + Z21^t Q2 + Q1 Z12 + Q12 Z2 */
/* ttemp3 = Q12^t Q12 + Z12^t Q12 + Q2 Z2 + Z2^t Q2 */

      mulmat1(rc,ttemp3,temp2,l,nm,n);
      mulmat1(rcm,temp4,temp3,l,nm,nm);
      addmat2(temp2,temp3,ttemp1,l,nm);
      eps = - (gf-g0)*gaman2 / gama; 
      scmat(eps,ttemp1,ttemp1,l,nm);

      mulmat1(cdot,ttemp3,temp2,l,nm,n);
      eps = - 0.5 * gaman2;
      scmat(eps,temp2,temp2,l,nm);
      addmat1(ttemp1,temp2,temp3,l,nm);

      setmat(0.0,att,nt,nt);    /* Compute A dot  */
      for(i=0;i<n;i++) 
	 for(j=0;j<n;j++) att[i][j]=adot[i][j];
 
      setmat(0.0,vtt,nt,nt);    /* Compute V dot   */
      mulmat3(bv,bdot,temp1,n,n,m);
      trans(temp1,temp2,n,n);
      addmat1(temp1,temp2,ttemp3,n,n);
      for(i=0;i<n;i++) 
	 for(j=0;j<n;j++) vtt[i][j]=ttemp3[i][j];
      mulmat3(bdot,bmv,temp1,n,nm,m)
      for(i=0;i<n;i++)
         for(j=n;j<nt;j++) 
             {vtt[i][j]=temp1[i][j-n];vtt[j][i]=vtt[i][j];}

      setmat(0.0,rtt,nt,nt);    /* Compute R dot   */
      mulmat2(cdot,rc,temp1,n,n,l);
      trans(temp1,temp2,n,n);
      addmat1(temp1,temp2,ttemp3,n,n);
      for(i=0;i<n;i++) 
	 for(j=0;j<n;j++) rtt[i][j]=ttemp3[i][j];
      mulmat2(cdot,rcm,temp1,n,nm,l)
      for(i=0;i<n;i++)
         for(j=n;j<nt;j++) 
             {rtt[i][j]= - temp1[i][j-n]; rtt[j][i]=rtt[i][j];}

      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Qt dot*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      addmat1(ttemp3,vtt,ttemp1,nt,nt);
      scmat(gaman2,rtt,ttemp2,nt,nt);
      mulmat1(qt,ttemp2,ttemp3,nt,nt,nt);
      mulmat1(ttemp3,qt,ttemp2,nt,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp1,nt,nt);

      mulmat1(qt, rt, ttemp2, nt,nt,nt);
      mulmat1(ttemp2,qt,ttemp3,nt,nt,nt);
      eps = - 2.0 *(gf - g0) *gaman2 / gama;
      scmat(eps, ttemp3, ttemp2, nt,nt);

      addmat4(ttemp1,ttemp2,ttemp1,nt,nt);
      
      tmparray(ttemp1,tarray2,nt,nt);

      mulmat1(qt,rt,ttemp1,nt,nt,nt);
      scmat(gaman2,ttemp1,ttemp2,nt,nt);
      addmat1(at,ttemp2,ttemp1,nt,nt);
      trarray(ttemp1,ua,nt,nt); 

      eps = 1.0e-26;
#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif


      tmpmatrix(tarray2,ttemp2,nt,nt);
      partition(ttemp2,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp2,rt,ttemp1,nt,nt,nt); /* Compute Ptilde dot */
      mulmat1(qt,rtt,ttemp2,nt,nt,nt); 
      addmat1(ttemp1,ttemp2,ttemp1,nt,nt);
      scmat(gaman2,ttemp1,ttemp2,nt,nt);
      addmat1(att,ttemp2,ttemp1,nt,nt);
      mulmat1(qt, rt, ttemp2, nt,nt,nt);
      eps = - 2.0*(gf - g0)*gaman2 / gama;
      scmat(eps, ttemp2, ttemp2, nt,nt);
      addmat1(ttemp1,ttemp2,ttemp1,nt,nt);

      mulmat2(ttemp1,pt,ttemp2,nt,nt,nt);
      trans(ttemp2,ttemp1,nt,nt);  
      addmat1(ttemp2,ttemp1,ttemp1,nt,nt);
      addmat4(ttemp1,rtt,ttemp2,nt,nt);
      tmparray(ttemp2,tarray2,nt,nt);
     
      eps = -1.0 ;
#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);

/* Compute derivative of H_Am       */
      
      mulmat2(ptd12,qt12,temp1,nm,nm,n); /*  Z2^(j) */
      mulmat2(pt12,qtd12,temp2,nm,nm,n);  
      addmat1(temp1,temp2,ttemp1,nm,nm);
      mulmat1(ptd2,qt2,temp1,nm,nm,nm);
      mulmat1(pt2,qtd2,temp2,nm,nm,nm);  
      addmat1(temp1,temp2,ttemp2,nm,nm);
      addmat1(ttemp1,ttemp2,ttemp1,nm,nm);
       
       j = 0;
       for(i=0;i<nm/2;i++){
          *(y+j) = ttemp1[2*i+1][2*i];
          *(y+j+1)  = ttemp1[2*i+1][2*i+1];
          j += 2;
        } 
        *(y + nm -1) = ttemp1[nm-1][nm-1];
 
/* Compute derivative of H_Bm       */
 
        mulmat1(bdot,v,temp2,n,m,m);
        mulmat2(pt12,temp2,temp1,nm,m,n);
        mulmat2(ptd12,bv,temp2,nm,m,n);
        addmat1(temp1,temp2,ttemp3,nm,m);
        mulmat1(ptd2,bmv,temp1,nm,m,nm);
 	addmat1(ttemp3,temp1,temp2,nm,m);

        toarray(nm,m,temp2,y+nm);
 
/* Compute derivatives of H_Cm     */
/* Original terms in temp1         */
       if(l != 1) {
        mulmat1(r,cdot,temp1,l,n,l);
        mulmat1(temp1,qt12,temp2,l,nm,n);
        mulmat1(rc,qtd12,temp1,l,nm,n); 
        addmat4(temp1,temp2,ttemp3,l,nm);
        mulmat1(rcm,qtd2,temp2,l,nm,nm);
        addmat1(temp2,ttemp3,temp1,l,nm);

/* Original terms + 1st term computed at the beginning */
	addmat1(temp1,temp3,temp1,l,nm);

        hcmterms();
        addmat1(temp1,temp3,temp2,l,nm);
      
        k = nm + nm*m;
        for(i=1;i<l;i++)
          for(j=0;j<nm;j++){
            *(y+k) = temp2[i][j];    
            k++;
         }
      }
}
