#include <stdio.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

extern FILE *in, *out,*out1;
extern void initp(), fixpnf(), atxpxa(), riccnd(), chkd(double *y); 
extern void free_dmatrix(), free_dvector(), free_ivector(); 
extern double **dmatrix(), *dvector();
extern int *ivector();

void track(double ansae, double arcae )
{
  int i,j, k;
  int iflag,nfe,ind,ip,*ipivot,n4 , trace  =0;
  double  eps=1.0e-26, aa[1], arclen, sspar[8], *wa;
  double  *x, ansre, arcre;
  
  wa = dvector(0,20*nn+nn*nn+10*n2*n2);
  x = dvector(0,nn);
  ipivot =ivector(0,nn);

  initp();

  *x = 0.0;          /* Transfer bm, cm to array x  */
  *(x+1) = am[0][0];
  k = 1;
  for(i=0;i< nm/2;i++){
   *(x+k) = am[2*i+1][2*i]; 
   *(x+k+1) = am[2*i+1][2*i+1]; 
   k += 2;
   }
  x[nm] = am[nm-1][nm-1];

  toarray(nm,m,bm,(x+1+nm));

  k = 1 + nm + nm*m;
  for(i=1;i<l;i++)
   for(j=0;j<nm;j++){
    *(x+k) = cm[i][j];
    k += 1;
   }

   addmat3(a,a0,adot,n,n);
   addmat3(b,b0,bdot,n,m);
   addmat3(c,c0,cdot,l,n);

#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+nn+1, &ip);
#else
   rho_(aa, x, x+1, wa, wa+nn+1, &ip);
#endif


/* Compute average values of the initial homotopy map */ 
 
   sspar[0]  =  0.0;
   for(i=0;i<nn;i++)  sspar[0] += myabs(*(wa+i));
    sspar[0] /= nn;
   if(sspar[0] > 1.0e-3)
     printf("\nThe initial homotopy  = %9.2E \n", sspar[0]);
 
   for(i=0;i<8; i++) *(sspar+i) = 0.0;
   iflag = -2;
   ip = 0;
   ansre = ansae;
   arcre = arcae;
 
/* Call tracking procedure             */ 
 
   for(i=0;i<10;i++){
n4 = nn + 1;
#if ((AIX) || (HP))
   fixpnf(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#else
   fixpnf_(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#endif

          &arclen,wa,wa+n4,wa+2*n4,wa+3*n4,wa+5*n4+n4*n4,
          wa+6*n4+n4*n4, ipivot,wa+7*n4+n4*n4,wa+8*n4+n4*n4,
          wa+9*n4+n4*n4,wa+10*n4+n4*n4,sspar,wa+11*n4+n4*n4,&ip);
      if(iflag != 3) break;
    }
 
#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+n4, &ip);
#else
   rho_(aa, x, x+1, wa, wa+n4, &ip);
#endif


   sspar[0] = 0.0;
   for(i=0;i<nn;i++) sspar[0] += myabs(*(wa+i));
     sspar[0] /= nn;
   if(sspar[0] > 1.0e-7)
     printf("\nThe final homotopy = %9.2E\n", sspar[0]);

   fprintf(out, "%d\n",iflag);    
   fprintf(out, "%20.15E\n",*x);

/* Compute the L^2 cost  */

   *sspar = 0;
   mulmat1(qt,rt,ttemp1,nt,nt,nt);
   for(i=0;i<nt;i++) *sspar += ttemp1[i][i];
   fprintf(out,"%19.7E\n", *sspar);

   trarray(at,uat,nt,nt);
   scmat(-1.0,vt,ttemp1,nt,nt);
   tmparray(ttemp1,ua,nt,nt);
#if ((AIX) || (HP))
   atxpxa(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ip);
#else
   atxpxa_(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ip);
#endif


   tmpmatrix(ua,qt,nt,nt);
   mulmat1(qt,rt,ttemp1,nt,nt,nt);

   sspar[0] =0.0;
   for(i=0;i<nt;i++) sspar[0] += ttemp1[i][i];
   fprintf(out,"%19.7E\n", sspar[0]);

/* Print Am, Bm, Cm in out.dat  */

      for(i=0;i<nm;i++)
       for(j=0;j<nm;j++) fprintf(out," %19.10E\n", am[i][j]);
      for(i=0;i<nm;i++)
        for(j=0;j<m;j++) fprintf(out," %19.10E\n",bm[i][j]);
      for(i=0;i<l;i++)
        for(j=0;j<nm;j++) fprintf(out," %19.10E\n",cm[i][j]);

   free_dvector(wa,0,20*nn+nn*nn+10*n2*n2);
   free_dvector(x,0,nn);
   free_ivector(ipivot,0,nn);
} 
