
#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#include "macro.h" 
#include "eglobal.h"

extern FILE *out;
extern void cg(), atxpxa(), free_dmatrix(),free_dvector(),
free_ivector();
extern double **dmatrix(int, int, int, int), *dvector(int, int);
extern int *ivector(int, int);

void initp()

/* Choosing the starting point (Bm, Cm)_0 for homotopy
  Results: Bm, Cm in input normal form (change in common block) */
{
	int ind ;
	register int i,j;
	double eps=1.0e-26, f10av, f20av;
	double **qr, *y, *yf;

	/* Transform the balanced (Ac, Bc, Cc) to the desired form */

	setmat(0.0,ac0,nc,nc);
	for(i=0;i<nc;i += 2) ac0[i][i+1] = 1.0;
	setmat(0.0,cc0,m,nc);
	for(i=0;i<nc;i += 2) cc0[0][i] = 1.0;

	/* Decide the transformation */

	if(nc == 1){
		ac0[0][0] = ac[0][0];
		cc0[0][0] = 1.0;
		eps = cc[0][0];
		scmat(eps,bc,bc0,nc,m);
		eps = 1.0/cc[0][0];
		scmat(eps,cc,cc0,m,nc);
		scmat(1.0,ac0,ac,nc,nc);
		scmat(1.0,bc0,bc,nc,l);
		scmat(1.0,cc0,cc,m,nc);
		return;
	}

	if(nc == 2){
		eps= (ac[0][1]* cc[0][0] -ac[0][0]*cc[0][1])*cc[0][0]
		    +(ac[1][1]* cc[0][0] -ac[1][0]*cc[0][1])*cc[0][1];
		temp1[1][0]= -(ac[0][0]*cc[0][0]+ac[1][0]*cc[0][1])/eps;
		temp1[1][1]= cc[0][0]/eps;
		temp1[0][0]= (1.0 - cc[0][1]*temp1[1][0])/cc[0][0];
		temp1[0][1]= -cc[0][1]/eps;

		eps = - temp1[0][1]*temp1[1][0] + temp1[0][0]*temp1[1][1];
		temp2[0][0]=  temp1[1][1]/eps; /* temp2 = temp1^-1 */
		temp2[0][1]= -temp1[0][1]/eps;
		temp2[1][0]= -temp1[1][0]/eps;
		temp2[1][1]=  temp1[0][0]/eps;
		ac0[1][0] = ac[0][1]*ac[1][0]-ac[0][0]*ac[1][1]; /* S1 */
		ac0[1][1] = ac[0][0] + ac[1][1];                 /* S2 */
		mulmat1(cc,temp1,cc0,m,nc,nc);
		mulmat1(temp2,bc,bc0,nc,l,nc);
		scmat(1.0,ac0,ac,nc,nc);
		scmat(1.0,bc0,bc,nc,l);
		scmat(1.0,cc0,cc,m,nc);
		return;
	}

	if(nc >= 3){
		int nc1, nc2, *ipvt, k, kk, nck, nck1;

		nc2 = nc*nc;
		qr = dmatrix(0,nc2,0,nc2);
		y = dvector(0,(nc+2)*(nc+2));
		yf = dvector(0,(nc+2)*(nc+2));
		ipvt = ivector(0,(nc+2)*(nc+2));


		/* Determine the eigenvalues of Am and order them */

		tmparray(ac,tarray1,nc,nc);
		ind = nc + 2;
		k = 0;
#if ((AIX) || (HP))
		rg(&ind,&nc,tarray1,er,ei,&k,temp1,ipvt,yf,&kk);
#else
		rg_(&ind,&nc,tarray1,er,ei,&k,temp1,ipvt,yf,&kk);
#endif

		k= 0;
		kk=  0;
		for(i=0;i<nc;i++){
			if(myabs(*(ei+i)) >= 1.0e-12) {
				*(ipvt+k) = i;
				k += 1;
			}
			else{
				*(ipvl+kk)= i;
				kk += 1;
			}
		}
		for(j=0;j<k;j++){
			*(y+j) = *(er+ipvt[j]);
			*(yf+j)= *(ei+ipvt[j]);
		}
		for(j=0;j<kk;j++){
			*(y+j+k) = *(er+ipvl[j]);
			*(yf+j+k)= *(ei+ipvl[j]);
		}

		/* Determine S */

		for(i=0;i<k;i += 2){
			*(scal+i) = -(y[i]*y[i] + yf[i]*yf[i]);
			*(scal+i+1) = 2*y[i];
		}

		for(i=k;i<nc;i += 2){
			*(scal+i) = - y[i]*y[i+1];
			*(scal+i+1) = y[i]+y[i+1];
		}

		if((nc-(nc/2)*2) > 0) *(scal+nc-1) = *(y+nc-1);

		/* Determine the coeff. matrix for Solving ac.T-T.S =0 and Cm.T =1010..
*/
		setmat(0.0, qr,nc2,nc2);

		for(k=0;k< nc/2;k++){
			nck = nc*2*(k+1);
			nck1= nc*2*k;
			for(i=0;i<nc;i++){
				for(j=0;j<nc;j++){
					qr[i+nck1][j+nck1] = ac[i][j];
					if(i == j)
						qr[i+nck1+nc][j+nck1+nc] = ac[i][j]-scal[2*k+1];
					else
						qr[i+nck1+nc][j+nck1+nc] = ac[i][j];
				}
			}

			for(j=0;j<nc;j++){
				qr[j+nck1][j+nck1+nc] = -scal[2*k];
				qr[j+nck1+nc][j+nck1] = -1.0;
			}
		}

		if((nc-(nc/2)*2) > 0){
			for(i=0;i<nc;i++)
				for(j=0;j<nc;j++){
					if(i == j)
						qr[i+nc*(nc-1)][j+nc*(nc-1)] = ac[i][j]-scal[nc-1];
					else
						qr[i+nc*(nc-1)][j+nc*(nc-1)] = ac[i][j];
				}
		}

		for(i=0;i<nc2;i += nc)
			for(j=0;j<nc2;j++)
				qr[i][j] = 0.0;

		k = 0;
		for(i=0;i<nc2;i += nc){
			for(j=0;j<nc;j++) qr[i][k*nc+j] = cc[0][j];
			k++;
		}

		/* The left hand side of the equation */

		for(i=0;i<nc2;i++) *(y+i) = 0.0;
		for(i=0;i<nc2;i += 2*nc) *(y+i) = 1.0;

		/* QR factorization of Coeff. matrix and solve for T*/

		tmparray(qr,tarray1,nc2,nc2);
		nc1 = nc2 + 2;
		k = 1;
#if ((AIX) || (HP))
/*      	dgefa(tarray1,&nc1,&nc2,ipvt,&ind); */
		dgesv(&nc2, &k, tarray1, &nc1,ipvt,y, &nc1,&ind); 
#else
/*      	dgefa_(tarray1,&nc1,&nc2,ipvt,&ind); */
		dgesv_(&nc2, &k, tarray1, &nc1,ipvt,y, &nc1,&ind); 
#endif

/*
		ind =0;
#if ((AIX) || (HP))
		dgesl(tarray1,&nc1,&nc2,ipvt,y,&ind);
#else
		dgesl_(tarray1,&nc1,&nc2,ipvt,y,&ind);
#endif

*/
		k = 0;
		for(i=0;i<nc;i++)
			for(j=0;j<nc;j++){
				temp1[j][i] = *(y+k);
				temp2[j][i] = *(y+k);
				k +=  1;
			}

		/* Compute the Inverse of T */
		tmparray(temp2,tarray1,nc,nc);
		nc1 = nc + 2;
#if ((AIX) || (HP))
		dgeco(tarray1,&nc1,&nc,ipvt,&eps,tarray2);
#else
		dgeco_(tarray1,&nc1,&nc,ipvt,&eps,tarray2);
#endif

		k = 1;
#if ((AIX) || (HP))
		dgedi(tarray1,&nc1,&nc,ipvt,tarray2,tarray2+3,&k);
#else
		dgedi_(tarray1,&nc1,&nc,ipvt,tarray2,tarray2+3,&k);
#endif


		tmpmatrix(tarray1,temp2,nc,nc);

		mulmat1(temp2,ac,temp3,nc,nc,nc);
		mulmat1(temp3,temp1,ac0,nc,nc,nc);
		mulmat1(cc,temp1,cc0,m,nc,nc);
		mulmat1(temp2,bc,bc0,nc,l,nc);

		free_dvector(y,0,(nc+2)*(nc+2));
		free_dvector(yf,0,(nc+2)*(nc+2));
		free_ivector(ipvt,0,(nc+2)*(nc+2));
		free_dmatrix(qr,0,nc2,0,nc2);
	}
	scmat(1.0,ac0,ac,nc,nc);
	scmat(1.0,bc0,bc,nc,l);
	scmat(1.0,cc0,cc,m,nc);
}
