#include "macro.h"
#include "eglobal.h"

extern void jaclam(), jacam(), jacbm(), jaccm();

#if ((AIX) || (HP))
void rhojac(double *aa, double *lambda,double *x,double *y,int *k,
#else
void rhojac_(double *aa, double *lambda,double *x,double *y,int *k,
#endif

       double *p,int *ip)
 
/* RHOJAC evaluates kk-th column of Jacobian at given point.
*
* Input parameters: lambda,x - input point (lambda,x)
* kk - column number
*
* Output parameters:
* y - evaluated function
*/
{ 
      int ik,jl, kk ;

/* Derivatives with respect to Amij          */

   kk = *k;
   if (kk > 1 && kk <= nc*nc+1){ 
      kk--;
      compij(kk,nc,ik,jl);
      jacam(*lambda, ik,jl,y);
      return;
  }

/* Derivatives with respect to Bmij          */

   if (kk > 1 + nc*nc && kk <= nc*nc+1 + nc*l){ 
      kk -= nc*nc + 1;
      compij(kk,l,ik,jl);
      jacbm(*lambda, ik,jl,y);
      return;
    }
      
/* Derivatives with respect to Cmij          */

   if (kk > l*nc + nc*nc + 1) {
      kk -= l*nc + nc*nc + 1;
      compij(kk,nc,ik,jl);
      jaccm(*lambda, ik,jl,y);
      return;
   }   

/* Derivatives with respect to lambda        */

   if (kk == 1) {
       jaclam(*lambda,y);
    }
}


