#include <stdio.h>
#include "macro.h"
#include "eglobal.h"

extern FILE  *out;
extern void atxpxa(), riccnd();

#if ((AIX) || (HP))
void rho(double *aa,double *lambda,double *x,double *y,
#else
void rho_(double *aa,double *lambda,double *x,double *y,
#endif
	 double *p,int *ip)

/* RHO evaluates the homotopy map rho(a lambda,x) at a given point 
* Input parameters:lambda,x - input point (lambda,x)
* Output parameters: * y - evaluated function
*/
{ 
      register int i,j;
      int ind, nt4;
      double eps;
 
      tomatrix(nm,m,bmi,x); /* Transform variable x to (Bm, Cm)*/
      tomatrix(l,nm,cmi,x+nm*m);
       
      gama = *lambda * gf + (1- *lambda)* g0;   /* gamma                  */
      gaman2 = 1/ (gama*gama);
 
      scmat(*lambda,adot,ttemp1,n,n);/*  A0 + lambda *(A- A0) in temp1 */ 
      addmat1(a0,ttemp1,temp1,n,n);

      scmat(*lambda,bdot,ttemp1,n,m);/*  B0 + lambda *(B - B0) in temp2*/
      addmat1(b0,ttemp1,temp2,n,m);
 
      scmat(*lambda,cdot,ttemp1,l,n);/*  C0 + lambda *(C - C0) in temp3*/
      addmat1(c0,ttemp1,temp3,l,n);
 
      mulmat1(temp2,v,bv,n,m,m); /*  BV, BVBm^t, and BVB^t */
      mulmat3(bv,bmi,bvbmt,n,nm,m);
      mulmat3(bv,temp2,bvbt,n,n,m);
 
      mulmat1(bmi,v,bmv,nm,m,m); /*  BmV, and Bm V Bm^T  */
      mulmat3(bmv,bmi,bmvbmt,nm,nm,m);
 
      mulmat1(r,temp3,rc,l,n,l); /*  RC, and C^t RC      */
      mulmat2(temp3,rc,ctrc,n,n,l) ;
 
      mulmat1(r,cmi,rcm,l,nm,l); /*  RCm, C^t RCm, and Cm^T R Cm */
      mulmat2(temp3,rcm,ctrcm,n,nm,l); 
      mulmat2(cmi,rcm,cmtrcm,nm,nm,l);
 
      setmat(0.00,ome,nm,nm); /* Compute ome and Ami   */
      for(i=0;i<nm;i++) ome[i][i] = cmtrcm[i][i]/bmvbmt[i][i];
 
      for(i=0;i<nm;i++){ 
        ami[i][i] = - 0.50*bmvbmt[i][i];
        for(j=0;j<nm;j++)
	 if(j != i)
          ami[i][j]=(cmtrcm[i][j]-ome[j][j]*bmvbmt[i][j])/
		   (ome[j][j]-ome[i][i]) ;
        }
       setmat(0.0,ttemp2,n,nm);
       takeblock(at,temp1,ttemp2,ami,n,nt);  /* A tilde */
       trarray(at,uat,nt,nt);
	
       scmat(-1.0, ctrcm, ttemp2,n,nm);
       takeblock(rt,ctrc,ttemp2,cmtrcm,n,nt); /* R tilde */
       scmat(gaman2,rt,rtt,nt,nt);
       scmat(-1.0,rtt,ttemp3,nt,nt);
       tmparray(ttemp3,vat,nt,nt);

       takeblock(vt,bvbt,bvbmt,bmvbmt,n,nt); /* V tilde */
       tmparray(vt,ua,nt,nt);

/* Solve At Q + Q At'  + r^-2 Q Rt Q + Vt =0 */ 

       nt4 = nt2 + 2;
#if ((AIX) || (HP))
       riccnd(&nt12,&nt12,&nt12,&nt4,&nt,&nt2,uat,vat,ua,
#else
       riccnd_(&nt12,&nt12,&nt12,&nt4,&nt,&nt2,uat,vat,ua,
#endif
	tarray1,tarray2,er,ei,work,scale,itype,ipvl,ipvs);   
 
       tmpmatrix(ua,qt,nt,nt);
       partition(qt,qt1,qt12,qt2,n,nt);

/* Check the solution of the above equation                 */

       mulmat1(at,qt,ttemp2,nt,nt,nt);
       trans(ttemp2,ttemp3,nt,nt);
       addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
       addmat1(ttemp1,vt,ttemp2,nt,nt);
       mulmat1(qt,rtt,ttemp1,nt,nt,nt);
       mulmat1(ttemp1,qt,ttemp3,nt,nt,nt);
       addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
       
       eps = 0.0e0;
       for(i=0;i<nt;i++)for(j=0;j<nt;j++){ 
	 if(eps < myabs(ttemp1[i][j])) eps = myabs(ttemp1[i][j]);
        }
       if(eps > 1.0e-4){
         printf("The precision in solving Riccati equation is %E \n",eps);
         printf("The Riccati solver failed\n");
         exit(1);
        }

/* Solve (At + r*r Q Rt)^t P  + P (At + r*r Q Rt) + Rt =0  */ 

       mulmat1(qt,rtt,ttemp1,nt,nt,nt); 
       addmat1(at,ttemp1,ttemp3,nt,nt);
       tmparray(ttemp3,uat,nt,nt);

       scmat(-1.0,rt,ttemp1,nt,nt);
       tmparray(ttemp1,tarray2,nt,nt);

       eps = 1.0e-26;
#if ((AIX) || (HP))
       atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
       atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

       tmpmatrix(tarray2,pt,nt,nt);
       partition(pt,pt1,pt12,pt2,n,nt);

      mulmat2(pt12,qt12,temp1,nm,nm,n);/* Compute J_Am = Z2 */
      mulmat1(pt2,qt2,temp2,nm,nm,nm);
      addmat1(temp1,temp2,zt2,nm,nm);

      mulmat1(pt1,qt1,temp1,n,n,n);   /* compute Z1  */
      mulmat3(pt12,qt12,temp2,n,n,nm);
      addmat1(temp1,temp2,zt1,n,n);

      mulmat1(pt1,qt12,temp1,n,nm,n); /* Compute Z12 */
      mulmat1(pt12,qt2,temp2,n,nm,nm);
      addmat1(temp1,temp2,zt12,n,nm);

      mulmat2(pt12,qt1,temp1,nm,n,n); /* Compute Z21 */
      mulmat3(pt2,qt12,temp2,nm,n,nm);
      addmat1(temp1,temp2,zt21,nm,n);

      for(j=0;j<nm;j++){ /* Compute Mo    */
	 for(i=j+1;i<nm;i++){
          mo[i][j] = (zt2[i][j] - zt2[j][i]) / (ome[j][j]-ome[i][i]);
          mo[j][i] = mo[i][j];}
        }
      for(i=0;i<nm;i++){
	mo[i][i] = 0.0;
	for(j=0; j<i;j++) mo[i][i] +=  ami[i][j]*mo[j][i]; 
	for(j=i+1; j<nm;j++) mo[i][i] +=  ami[i][j]*mo[j][i]; 
        mo[i][i] /= - ami[i][i];
       }

      for(i=0;i<nm;i++) /* Compute Mc    */
	for(j=0; j<nm;j++) 
           mc[i][j] = - zt2[i][j] - ome[i][i] * mo[i][j];

      mulmat2(pt12,bv,temp1,nm,m,n);/* The homotopy H_Bm */ 
      addmat1(pt2,mc,temp2,nm,nm);
      mulmat1(temp2,bmv,temp3,nm,m,nm);
      addmat1(temp1,temp3,temp2,nm,m);
      toarray(nm,m,temp2,y);
 
      addmat1(qt2,mo,temp1,nm,nm);  /* The homotopy H_Cm */
      mulmat1(rcm,temp1,temp2,l,nm,nm); /* RCm (Q2 + Mo) */
      mulmat1(rc,qt12,temp3,l,nm,n);    /* RC Q12        */
      addmat3(temp2,temp3,ttemp1,l,nm); /* Sum of 2 terms in ttemp1*/ 

      mulmat2(zt1,qt12,temp2,n,nm,n); /* Z1^t Q12    */
      mulmat2(zt21,qt2,temp3,n,nm,nm);/* Z21^t Q2    */
      addmat1(temp2,temp3,temp1,n,nm); /* sum in temp1 */
      mulmat1(qt1,zt12,temp2,n,nm,n);  /* Q1 Z12    */
      mulmat1(qt12,zt2,temp3,n,nm,nm); /* Q12 Z2    */
      addmat1(temp2,temp3,ttemp2,n,nm);/* sum in ttemp2 */
      addmat1(temp1,ttemp2,ttemp3,n,nm);/* sum of 4 terms in ttemp3 */
      mulmat1(rc,ttemp3,temp1,l,nm,n);
      eps = -0.5 * gaman2;
      scmat(eps,temp1,temp2,l,nm);

      mulmat2(zt12,qt12,temp1,nm,nm,n); /* Z12^t Q12 */
      mulmat2(qt12,zt12,temp3,nm,nm,n); /* Q12^t Z12 */
      addmat1(temp1,temp3,temp3,nm,nm); /* sum in temp3 */
      mulmat1(qt2,zt2,temp1,nm,nm,nm); /* Q2 Z2   */
      mulmat2(zt2,qt2,temp4,nm, nm,nm); /* Z2^t Q2 */
      addmat1(temp1,temp4,temp4,nm,nm);/* sum in temp4 */
      addmat1(temp3,temp4,temp4,nm,nm);/* sum of 4 terms in temp4 */
      mulmat1(rcm,temp4,temp1,l,nm,nm);
      eps = -eps;
      scmat(eps,temp1,temp3,l,nm);

      addmat1(temp2,temp3,temp1,l,nm);

      addmat1(ttemp1,temp1,temp2,l,nm);
      toarray(l,nm,temp2,y+m*nm);
}
