function [ac,bc,cc,cost] = flqginf(a,b,c,d,gamma0,gamma,e1,e2,e1i,e2i,d1,d2)

% Find the sizes of the system and check the dimensions 
[nr,nc] = size(a);
if (nr ~= nc), error('Nonsquare A matrix'); end;

[n,m] = size(b);
if (nr~=n), error('Incorrectly dimensioned B matrix'); end;

[l,nc] = size(c);
if (nc~=n), error('Incorrectly dimensioned C matrix'); end;

% Set the starting gamma
if (gamma <= 0.0), error('gamma must be greater than zero'); end;

[ac,bc,cc,cost] = LQGcont(a,b,c,d,d1,d2,e1,e2);
[ac,bc,cc,Ome]= inormric(ac,bc,cc);

r1 =  e1'* e1;
r2 =  e2'* e2;
r1i = e1i' * e1i;
r2i = e2i' * e2i;
v1 = d1* d1';
v2 = d2* d2';

% Set the precision for HOMPACK routines

arcre = 1.0e-5;
ansre = 1.0e-9;

% Write the data into file 'in.dat' to be read by the executable
in = fopen('in.dat','w');

fprintf(in, '%u  %u  %u  %u\n',n,nc,m,l);

fprintf(in, '%e  %e  %e  %e\n',arcre,ansre,gamma0,gamma);

for i=1:n
  for j=1:n
    fprintf(in, '%17.9e\n',a(i,j));
  end
end
   
for i=1:n
  for j=1:m
    fprintf(in, '%17.9e\n',b(i,j));
  end
end

for i=1:l
  for j=1:n
    fprintf(in, '%17.9e\n',c(i,j));
  end
end
for i=1:nc
  for j=1:nc
    fprintf(in, '%17.9e\n',ac(i,j));
  end
end

for i=1:nc
  for j=1:l
    fprintf(in, '%17.9e\n',bc(i,j));
  end
end

for i=1:m
  for j=1:nc
    fprintf(in, '%17.9e\n',cc(i,j));
  end
end
for i=1:n
  for j=1:n
    fprintf(in, '%17.9e\n',r1(i,j));
  end
end

for i=1:m
  for j=1:m
    fprintf(in, '%17.9e\n',r2(i,j));
  end
end

for i=1:n
  for j=1:n
    fprintf(in, '%17.9e\n',r1i(i,j));
  end
end

for i=1:m
  for j=1:m
    fprintf(in, '%17.9e\n',r2i(i,j));
  end
end
for i=1:n
  for j=1:n
    fprintf(in, '%17.9e\n',v1(i,j));
  end
end

for i=1:l
  for j=1:l
    fprintf(in, '%17.9e\n',v2(i,j));
  end
end


fclose(in);

% Execute the function to find the solution (Am, Bm, Cm)
!fulLQGly  

load hi.dat;

iflag = hi(1,1);
nc = hi(2,1);
gamma=hi(3,1);

nt = n + nc;

if(iflag == 2), error('Specified error tolerrance can not be met.'); end;

if(iflag == 3), error('Stepnf  has been called 1000 times.'); end;

if(iflag == 4), error('jacobian matrix does not have full rank'); end;

if(iflag == 5), error('Tracking algorithm has lost the zero curve.'); 
fprintf(1,'Use smaller arcre and ansre in flqginf.m\n'); end;

if(iflag == 6), 
fprintf(1, 'The final lambda %lf\n', lambda), 
error('Make gamma0 smaller or ancre and ansre in flqginf.m larger and try again.'); end;

k=3; 

for i=1:nc
 for j=1:nc
 k=k+1;
 ac(i,j) = hi(k,1);
 end
end

 for j=1:nc
 k=k+1;
 bct(1,j) = hi(k,1);
 end

bc=bct' ;

 for j=1:nc
 k=k+1;
 cc(1:1,j) = hi(k,1);
 end

 k=k+1;
 scost = hi(k,1);
 k=k+1;
 cost  = hi(k,1);
