function [test] = initchk(ac,bc,cc,dc,a,b,c,d,d1,d2,e1,e2,e0)
%function [test] = initchk(ac,bc,cc,dc,a,b,c,d,d1,d2,e1,e2,e0)
%
%
% INITCHK determines if the controller represented by {ac,
% bc, cc, dc} yields a stable closed loop transfer function
% when connected to the TITO system represented by {a,b,c,d,d1,
% d2,e1,e2,e0}
%

%================================================================
% WRITTEN: Richard S. Erwin
%          05 July 1993
%          University of Michigan
%
% REVISED: Richard S. Erwin
%          15 February 1994
%          Kirtland AFB, NM
%=================================================================
%
% Load System Variables
%
	if nargin <= 2
      		[a,d1,b,e1,c,e0,e2,d2,d] = branch(bc);
		[ac,bc,cc,dc] = branch(ac);
	end
%
%  Determine Closed-Loop system:
%
	Acl = [a,b*cc;bc*c,ac+bc*d*cc];
%
% check stability
%
      eigvec = eig(Acl);
%
   realroot = real(eigvec);
%
       test = max(realroot >= 0);
%
%       if test == 1,
%                disp('closed loop system unstable -- try again')
%       elseif test == 0,
%                disp('closed loop system stable -- initial controller good')
%       end



Return-path: <rserwin@engin.umich.edu>
Received: from pipercub.engin.umich.edu (rserwin@pipercub.engin.umich.edu)
 by Butler.EDU (PMDF V4.3-10 #6691) id <01HNUP25ZWI89ZNBOM@Butler.EDU>; Tue,
 07 Mar 1995 11:09:03 -0500 (EST)
Received: (rserwin@localhost) by pipercub.engin.umich.edu (8.6.10/8.6.4)
 id LAA04484 for GE@Butler.EDU; Tue, 7 Mar 1995 11:08:15 -0500
Date: Tue, 07 Mar 1995 11:08:15 -0500
From: Richard Scott Erwin <rserwin@engin.umich.edu>
To: GE@Butler.EDU
Message-id: <199503071608.LAA04484@pipercub.engin.umich.edu>
Content-transfer-encoding: 7BIT

function [test] = initchk(ac,bc,cc,dc,a,b,c,d,d1,d2,e1,e2,e0)
%function [test] = initchk(ac,bc,cc,dc,a,b,c,d,d1,d2,e1,e2,e0)
%
%
% INITCHK determines if the controller represented by {ac,
% bc, cc, dc} yields a stable closed loop transfer function
% when connected to the TITO system represented by {a,b,c,d,d1,
% d2,e1,e2,e0}
%

%================================================================
% WRITTEN: Richard S. Erwin
%          05 July 1993
%          University of Michigan
%
% REVISED: Richard S. Erwin
%          15 February 1994
%          Kirtland AFB, NM
%=================================================================
%
% Load System Variables
%
	if nargin <= 2
      		[a,d1,b,e1,c,e0,e2,d2,d] = branch(bc);
		[ac,bc,cc,dc] = branch(ac);
	end
%
%  Determine Closed-Loop system:
%
	Acl = [a,b*cc;bc*c,ac+bc*d*cc];
%
% check stability
%
      eigvec = eig(Acl);
%
   realroot = real(eigvec);
%
       test = max(realroot >= 0);
%
%       if test == 1,
%                disp('closed loop system unstable -- try again')
%       elseif test == 0,
%                disp('closed loop system stable -- initial controller good')
%       end


