
function [am,bm,cm,cost] = morh2hily(a,b,c,nm,gamma)

% Find the sizes of the system and check the dimensions 
[nr,nc] = size(a);
if (nr ~= nc), error('Nonsquare A matrix'); end;

[n,m] = size(b);
if (nr~=n), error('Incorrectly dimensioned B matrix'); end;

[l,nc] = size(c);
if (nc~=n), error('Incorrectly dimensioned C matrix'); end;

% Check the size of the reduced order model
if (nm >= n), error('Incorrectly dimensioned reduced model'); end;

% Set the starting gamma
if (gamma <= 0.0), error('gamma must be greater than zero'); end;

gamma0 = gamma*1000;

% Set the precision for HOMPACK routines

arcre = 1.0e-5;
ansre = 1.0e-9;

% Write the data into file 'in.dat' to be read by the executable
in = fopen('in.dat','w');

fprintf(in, '%u  %u  %u  %u\n',n,nm,m,l);

fprintf(in, '%e  %e  %e  %e\n',arcre,ansre,gamma0,gamma);

for i=1:n
  for j=1:n
    fprintf(in, '%17.9e\n',a(i,j));
  end
end
   
for i=1:n
  for j=1:m
    fprintf(in, '%17.9e\n',b(i,j));
  end
end

for i=1:l
  for j=1:n
    fprintf(in, '%17.9e\n',c(i,j));
  end
end

fclose(in);

% Execute the function to find the solution (Am, Bm, Cm)
!gely  

load out.dat;

iflag = out(1,1);
lambda = out(2,1);

if(iflag == 2), error('Specified error tolerrance can not be met.'); end;

if(iflag == 3), error('Stepnf  has been called 1000 times.'); end;

if(iflag == 4), error('jacobian matrix does not have full rank'); end;

if(iflag == 5), error('Tracking algorithm has lost the zero curve.'); 
fprintf(1,'Use smaller arcre and ansre in morh2hily.m\n'); end;

if(iflag == 6), 
fprintf(1,'The final lambda %lf\n', lambda), 
error('Make gamma0 smaller or ancre and ansre in morh2hily.m larger and try again.'); end;

scost = out(3,1);
cost  = out(4,1); 

k = 4;

for i=1:nm
 for j=1:nm
 k=k+1;
 am(i,j) = out(k,1);
 end
end

for i=1:nm
 for j=1:m
 k=k+1;
 bm(i,j) = out(k,1);
 end
end

for i=1:l
 for j=1:nm
 k=k+1;
 cm(i,j) = out(k,1);
 end
end
