      subroutine mulmat(ld,a,b,c,m,n,k,type)
*
* Perform matrix-matrix multiplication: C(m,n) = A(m,k) * B(k,n)
* NOTE: A or B may be used as A^t or B^t, depending on type, i.e.,
*       if type=2 then C(m,n) = A^t(m,k) * B(k,n)
* type - 1 - C = A * B
*        2 - C = A^t * B
*        3 - C = A * B^t
*        4 - C = A^t * B^t
*
      integer i,j,k,ld,m,n,type
      double precision a(ld,ld),b(ld,ld),c(ld,ld),ddot
*
      do 301 j = 1,n
        do 302 i = 1,m
          goto (403,404,405,406) type
403       c(i,j) = ddot(k,a(i,1),ld,b(1,j),1)
          goto 302
404       c(i,j) = ddot(k,a(1,i),1,b(1,j),1)
          goto 302
405       c(i,j) = ddot(k,a(i,1),ld,b(j,1),ld)
          goto 302
406       c(i,j) = ddot(k,a(1,i),1,b(j,1),ld)
302     continue
301   continue
      return
      end
