*
*     XMAT
*
      subroutine xmat(ld,xtyp,dim1,dim2,mat,x)
*
* Depending on type, transfer vector to matrix or vice versa
* type - 1 - transfer vector X to MAT(dim1,dim2)
*        2 - transfer MAT(dim1,dim2) to vector X
*
      integer i,j,ld,xtyp,count,dim1,dim2
      double precision mat(ld,ld),x(*)
*
      count = 1
*
      do 301 i = 1,dim1
        do 302 j = 1,dim2
          if (xtyp .eq. 1) mat(i,j) = x(count)
          if (xtyp .eq. 2) x(count) = mat(i,j)
          count = count + 1
302     continue
301   continue
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     XWUS
*
      subroutine xwus(ld,n,nm,xtyp,ww,wi,sigma,x)
*
* Depending on type, transfer vector X to matrix form or vice versa
* type - 1 - transfer vector X to (W,U,Sigma)
*        2 - transfer (W,U,Sigma) to vector X 
*
      integer ld,n,nm,xtyp
      double precision ww(ld,ld),wi(ld,ld),sigma(ld,ld)
      double precision x(*)
*
      call xmat(ld,xtyp,n,nm,ww,x(1))
      call xmat(ld,xtyp,nm,n,wi,x(n*nm+1))
      call xmat(ld,xtyp,nm,nm,sigma,x(2*n*nm+1))
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     COL2X
*
      subroutine col2x(ld,dim1,dim2,mat,x)
*
* Transfer MAT(dim1,dim2) to vector X, column by column
*
      integer i,j,ld,count,dim1,dim2
      double precision mat(ld,ld),x(*)
*
      count = 1
*
      do 301 j = 1,dim2
        do 302 i = 1,dim1
          x(count) = mat(i,j)
          count = count + 1
302     continue
301   continue
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     SYMMET
*
      subroutine symmet(ld,n,nm,x,ww,wi,sigma)
*
      integer i,j,ld,n,nm,xtyp
      double precision ww(ld,ld),wi(ld,ld),sigma(ld,ld)
      double precision x(*),t1
*
      xtyp = 1
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,x)
*
      if (nm .ge. 2) then
        do 301 i = 1,nm-1
          do 302 j = i+1,nm
            t1 = 0.5d0 * (sigma(i,j) + sigma(j,i))
            sigma(i,j) = t1
            sigma(j,i) = t1
302       continue
301     continue
      endif
*
      xtyp = 2
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,x)
*      call xmat(ld,xtyp,n,nm,ww,x)
*      call xmat(ld,xtyp,nm,n,wi,x(1+n*nm))
*      call xmat(ld,xtyp,nm,nm,sigma,x(1+2*n*nm))
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     CCURV2
*
      subroutine ccurv2(ld,n,nm,x,p1,p2,f10,f20,f30,temp1,temp2,temp3,
     &                  aal,tempf0)
*
      integer ld,n,nm,xtyp
      integer p2(*)
      double precision f10(ld,ld),f20(ld,ld),f30(ld,ld)
      double precision aal(ld,ld),temp1(ld,ld),temp2(ld,ld),temp3(ld,ld)
      double precision x(*),p1(*),tempf0(ld*ld),aa(1)
      double precision t1
*
      call rho(aa,x(1),x(2),tempf0,p1,p2)
*
      xtyp = 1
      call xmat(ld,xtyp,nm,n,aal,tempf0)
      call xmat(ld,xtyp,n,nm,temp2,tempf0(n*nm+1))
      call xmat(ld,xtyp,nm,nm,temp3,tempf0(2*n*nm+1))
*
      t1 = 1.d0 - x(1)
      call scmat(ld,t1,f10,temp1,nm,n)
      call addmat(ld,temp1,aal,aal,nm,n,1)
      call scmat(ld,t1,f20,temp1,n,nm)
      call addmat(ld,temp1,temp2,temp2,n,nm,1)
      call scmat(ld,t1,f30,temp1,nm,nm)
      call addmat(ld,temp1,temp3,temp3,nm,nm,1)
*
      t1 = 1.d0/t1
      call scmat(ld,t1,aal,f10,nm,n)
      call scmat(ld,t1,temp2,f20,n,nm)
      call scmat(ld,t1,temp3,f30,nm,nm)
*
      return
      end
*
