*
*     READ1
*
      subroutine read1(n,nm,m,l,trace)
*
      integer n,nm,m,l,trace
*
*     read n,nm,m,l
*
      read(1,101)n,nm,m,l
101   format(4i3)
      if (trace .ne. 0) then
        write(trace,201)n,nm,m,l
201     format(/'n=',i2,'   nm=',i2,'   m=',i2,'   l=',i2)
      endif
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     READ2
*
      subroutine read2(ld,n,m,l,trace,a,b,c)
*
      integer ld,n,m,l,i,j,trace
      double precision a(ld,ld),b(ld,ld),c(ld,ld)
*
      do 301 i = 1,n
        do 302 j = 1,n
          read(1,103)a(i,j)
103       format(d22.15)
302     continue
301   continue
*
      do 303 i = 1,n
        do 304 j = 1,m
          read(1,104)b(i,j)
104       format(d22.15)
304     continue
303   continue
*
      do 305 i = 1,l
        do 306 j = 1,n
          read(1,105)c(i,j)
105       format(d22.15)
306     continue
305   continue
*
      if (trace .ne. 0) then
        write(trace,201)
201     format(/'A')
        call writem(ld,a,n,n)
        write(trace,203)
203     format(/'B')
        call writem(ld,b,n,m)
        write(trace,205)
205     format(/'C')
        call writem(ld,c,l,n)
      endif
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     VR
*
      subroutine vr(ld,m,l,v,r)
*
      integer ld,m,l,i
      double precision v(ld,ld),r(ld,ld)
*
      call setmat(ld,0.d0,v,m,m)
      do 301 i = 1,m
        v(i,i) = 1.d0
301   continue
      call setmat(ld,0.d0,r,l,l)
      do 302 i = 1,l
        r(i,i) = 1.d0
302   continue
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     BVRC
*
      subroutine bvrc(ld,n,m,l,b,c,bvbt,ctrc,v,r,temp1)
*
      integer ld,n,m,l
      double precision b(ld,ld),c(ld,ld),bvbt(ld,ld),ctrc(ld,ld)
      double precision v(ld,ld),r(ld,ld),temp1(ld,ld)
*
      call mulmat(ld,b,v,temp1,n,m,m,1)
      call mulmat(ld,temp1,b,bvbt,n,n,m,3)
      call mulmat(ld,c,r,temp1,n,l,l,2)
      call mulmat(ld,temp1,c,ctrc,n,n,l,1)
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     INITP1
*
      subroutine initp1(ld,n,nm,nn,hom,c1,c2,q,p,ww,wi,sigma,
     &                  temp1,temp2,ipvt)
*
      integer ld,n,nm,nn,hom,i,job
      integer ipvt(ld)
      double precision q(ld,ld),p(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld)
      double precision ww(ld,ld),wi(ld,ld),sigma(ld,ld)
      double precision rcond,det,t1,t2,c1,c2
*
      hom = 0
*
      call setmat(ld,0.d0,sigma,n,n)
      t2 = 1.d0
      t1 = t2
      do 301 i = 1,n
        sigma(i,i) = t1
        t1 = t1 + t2
301   continue
*
      t1 = 0.5d0 * (1.d0 / dble(n))
      call setmat(ld,t1,ww,n,n)
      do 302 i = 1,n
        ww(i,i) = 1.d0
302   continue
      call scmat(ld,1.d0,ww,wi,n,n)
*
      job = 01
      call dgeco(wi,ld,n,ipvt,rcond,temp2)
      call dgedi(wi,ld,n,ipvt,det,temp2,job)
*
      call mulmat(ld,ww,sigma,temp1,n,n,n,1)
      call mulmat(ld,temp1,ww,q,n,n,n,3)
      call mulmat(ld,wi,sigma,temp1,n,n,n,2)
      call mulmat(ld,temp1,wi,p,n,n,n,1)
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     INITP2
*
      subroutine initp2(ld,n,nm,nn,c1,c2,d,bvbt,ctrc,y,hom,q,p,tau,
     &                  f10,f20,f30,ww,wi,sigma,temp1,temp2,temp3,aal,
     &                  gc,go,work,qr,wa,fvec,s1)
*
* Strategy 2 for choosing the starting point for homotopy
*
* Input parameters:
* ld - leading dimension of matrices
* n,nm - dimensions of system and model
* nn - Jacobian size
* c1,c2 - parameters used in definition of D
* d,bvbt,ctrc - D, B V B^t, C^t R C
*
* Output parameters:
* y - point in vector form
* hom - parameter indicating which homotopy map will be used, depends
*       on the result of quasi-Newton iteration
*
* Working storage:
* q,p,tau,f10,f20,f30,ww,wi,sigma,temp1,temp2,temp3,aal,gc,go,work,qr
*   - working matrices
* wa,fvec,s1 - working arrays
*
      integer hom,i,ind,job,ld,n,nm,nn,z
      double precision aal(ld,ld),bvbt(ld,ld),c1,c2,ctrc(ld,ld),d(ld,ld)
      double precision eps,f10(ld,ld),f20(ld,ld),f30(ld,ld),fvec(nn)
      double precision gc(ld,ld),go(ld,ld),p(ld,ld),q(ld,ld),qr(nn,nn)
      double precision s1(ld),sigma(ld,ld),tau(ld,ld),temp1(ld,ld)
      double precision temp2(ld,ld),temp3(ld,ld),wa(nn*(nn+13)/2)
      double precision wi(ld,ld),work(ld,ld),ww(ld,ld),y(nn)
*
      job = 11
      z = ld * ld
      eps = 1.d-16
*
* Compute controllability Gramian Gc
*
      call trans(ld,d,temp2,n,n)
      call scmat(ld,-1.d0,bvbt,temp1,n,n)
      call atxpxa(temp2,aal,temp1,n,ld,ld,ld,eps,ind)
      call scmat(ld,1.d0,temp1,gc,n,n)
*
* Compute Q, the Gc rank-nm approximation
*
      call dsvdc(temp1,ld,n,n,s1,aal,temp2,ld,temp3,ld,work,job,info)
      call setmat(ld,0.d0,sigma,n,n)
      do 321 i = 1,nm
        sigma(i,i) = s1(i)
321   continue
      call mulmat(ld,temp2,sigma,temp1,n,n,n,1)
      call mulmat(ld,temp1,temp3,q,n,n,n,3)
*
* Compute observability Gramian Go
*
      call scmat(ld,1.d0,d,temp2,n,n)
      call scmat(ld,-1.d0,ctrc,temp1,n,n)
      call atxpxa(temp2,aal,temp1,n,ld,ld,ld,eps,ind)
      call scmat(ld,1.d0,temp1,go,n,n)
*
* Compute P, the Go rank-nm approximation
*
      call dsvdc(temp1,ld,n,n,s1,aal,temp2,ld,temp3,ld,work,job,info)
      call setmat(ld,0.d0,sigma,n,n)
      do 322 i = 1,nm
        sigma(i,i) = s1(i)
322   continue
      call mulmat(ld,temp2,sigma,temp1,n,n,n,1)
      call mulmat(ld,temp1,temp3,p,n,n,n,3)
*
* Compute (W,U,Sigma) for given (Q,P)
*
      call cg(ld,n,nm,q,p,ww,wi,sigma,tau,temp1,temp2,temp3,
     &        wa(1),wa(z+1),wa(2*z+1),wa(3*z+1),wa(4*z+1),wa(5*z+1),
     &        wa(6*z+1),wa(7*z+1),wa(8*z+1),wa(9*z+1),wa(10*z+1),
     &        wa(11*z+1))
*
      write(2,231)
231   format(/'sigma')
      call writem(ld,sigma,nm,nm)
*
* Quasi-Newton iteration
*
*      call apprd(ld,n,nm,nn,hom,y,d,bvbt,ctrc,ww,wi,sigma,f10,f20,f30,
*     &           temp1,temp2,temp3,qr,wa,fvec,s1)
*      if (hom .ne. 1) hom = 0
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     INITP3
*
      subroutine initp3(ld,n,nm,m,l,nn,c1,c2,d,bvbt,ctrc,b,c,v,r,y,hom,
     &                  q,p,tau,f10,f20,f30,ww,wi,sigma,temp1,temp2,
     &                  temp3,qr,wa,fvec,s1)
*
* Strategy 3 for choosing the starting point for homotopy
*
* Input parameters:
* ld - leading dimension of matrices
* n,nm,m,l - dimensions of system and model
* nn - Jacobian size
* c1,c2 - parameters used in definition of D
* d,bvbt,ctrc,d,b,c,v,r - D, B V B^t, C^t R C, B, C, V, R
*
* Output parameters:
* y - point in vector form
* hom - parameter indicating which homotopy map will be used, depends
*       on the result of quasi-Newton iteration
*
* Working storage:
* q,p,tau,f10,f20,f30,ww,wi,sigma,temp1,temp2,temp3,qr - working matrices
* wa,fvec,s1 - working arrays
*
      integer i,l,ld,m,n,nm,nn,z
      double precision b(ld,ld),bvbt(ld,ld),c(ld,ld),c1,c2,ctrc(ld,ld)
      double precision d(ld,ld),f10(ld,ld),f20(ld,ld),f30(ld,ld)
      double precision fvec(nn),p(ld,ld),q(ld,ld),qr(nn,nn),r(ld,ld)
      double precision s1(ld),sigma(ld,ld),small,t1,t2,tau(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld),temp3(ld,ld),v(ld,ld)
      double precision wa(nn*(nn+13)/2),wi(ld,ld),ww(ld,ld),y(nn)
*
      z = ld * ld
      small = 1.d-3
*
* Augment B to TEMP1
*
      call setmat(ld,0.d0,temp1,n,nm)
      call scmat(ld,1.d0,b,temp1,n,m)
      t1 = 1.d-1
      t2 = 1.d-1 / dble(n*n)
      do 311 i = 1,nm
        if (dabs(temp1(i,i)) .lt. t1) temp1(i,i) = t1
        t1 = t1 + t2
311   continue
*
* Compute augmented (rank-nm) product B V B^t
*
      call setmat(ld,0.d0,temp2,nm,nm)
      call scmat(ld,1.d0,v,temp2,m,m)
      if (nm .gt. m) then
        do 301 i = m+1,nm
          temp2(i,i) = 1.d0
301     continue
      endif
      call mulmat(ld,temp1,temp2,temp3,n,nm,nm,1)
      call mulmat(ld,temp3,temp1,temp2,n,n,nm,3)
      t1 = 1.d0 / (2.d0 * c1)
      call scmat(ld,t1,temp2,q,n,n)
*
* Augment C to TEMP1
*
      call setmat(ld,0.d0,temp1,nm,n)
      call scmat(ld,1.d0,c,temp1,l,n)
      t1 = 1.d-1
      t2 = 1.d-1 / dble(n*n)
      do 313 i = 1,nm
        if (dabs(temp1(i,i)) .lt. t1) temp1(i,i) = t1
        t1 = t1 + t2
313   continue
*
* Compute augmented (rank-nm) product C^t R C
*
      call setmat(ld,0.d0,temp2,nm,nm)
      call scmat(ld,1.d0,r,temp2,l,l)
      if (nm .gt. l) then
        do 302 i = l+1,nm
          temp2(i,i) = 1.d0
302     continue
      endif
      call mulmat(ld,temp1,temp2,temp3,n,nm,nm,2)
      call mulmat(ld,temp3,temp1,temp2,n,n,nm,1)
      t1 = 1.d0 / (2.d0 * c1)
      call scmat(ld,t1,temp2,p,n,n)
*
* Compute (W,U,Sigma) for given (Q,P)
*
      call cg(ld,n,nm,q,p,ww,wi,sigma,tau,temp1,temp2,temp3,
     &        wa(1),wa(z+1),wa(2*z+1),wa(3*z+1),wa(4*z+1),wa(5*z+1),
     &        wa(6*z+1),wa(7*z+1),wa(8*z+1),wa(9*z+1),wa(10*z+1),
     &        wa(11*z+1))
*
      write(2,231)
231   format(/'sigma')
      call writem(ld,sigma,nm,nm)
*
* Quasi-Newton iteration
*
*      call apprd(ld,n,nm,nn,hom,y,d,bvbt,ctrc,ww,wi,sigma,f10,f20,f30,
*     &           temp1,temp2,temp3,qr,wa,fvec,s1)
*      if (hom .ne. 1) hom = 0
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     INITP4
*
      subroutine initp4(ld,n,nm,m,l,nn,c1,c2,d,bvbt,ctrc,y,hom,q,p,tau,
     &                  f10,f20,f30,ww,wi,sigma,temp1,temp2,temp3,
     &                  qr,wa,fvec,s1)
*
* Strategy 4 for choosing the starting point for homotopy
*
* Input parameters:
* ld - leading dimension of matrices
* n,nm,m,l - dimensions of system and model
* nn - Jacobian size
* c1,c2 - parameters used in definition of D
* d,bvbt,ctrc - D, B V B^t, C^t R C
*
* Output parameters:
* y - point in vector form
* hom - parameter indicating which homotopy map will be used, depends
*       on the result of quasi-Newton iteration
*
* Working storage:
* q,p,tau,f10,f20,f30,ww,wi,sigma,temp1,temp2,temp3,qr - working matrices
* wa,fvec,s1 - working arrays
*
      integer i,l,ld,m,n,nm,nn,realnm,z
      double precision bvbt(ld,ld),c1,c2,ctrc(ld,ld),d(ld,ld),f10(ld,ld)
      double precision f20(ld,ld),f30(ld,ld),fvec(nn),p(ld,ld),q(ld,ld)
      double precision qr(nn,nn),s1(ld),sigma(ld,ld),small,t1,tau(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld),temp3(ld,ld)
      double precision wa(nn*(nn+13)/2),wi(ld,ld),ww(ld,ld),y(nn)
*
      z = ld * ld
      small = 1.d-4
*
* Compute solutions of initial problem with ranks m and l
*
      t1 = 1.d0 / (2.d0 * c1)
      call scmat(ld,t1,bvbt,q,n,n)
      call scmat(ld,t1,ctrc,p,n,n)
*
* nm = min{m,l}
*
      realnm = nm
      nm = m
      if (l .lt. nm) nm = l
*
* Compute (W,U,Sigma) for given (Q,P), rank nm-1
*
      call cg(ld,n,nm,q,p,ww,wi,sigma,tau,temp1,temp2,temp3,
     &        wa(1),wa(z+1),wa(2*z+1),wa(3*z+1),wa(4*z+1),wa(5*z+1),
     &        wa(6*z+1),wa(7*z+1),wa(8*z+1),wa(9*z+1),wa(10*z+1),
     &        wa(11*z+1))
*
* Augment Sigma
*
      if (nm .lt. realnm) then
        do 302 i = nm+1,realnm
          sigma(i,i) = small
302     continue
      endif
*
      nm = realnm
*
      write(2,231)
231   format(/'sigma')
      call writem(ld,sigma,nm,nm)
*
* Quasi-Newton iteration
*
*      call apprd(ld,n,nm,nn,hom,y,d,bvbt,ctrc,ww,wi,sigma,f10,f20,f30,
*     &           temp1,temp2,temp3,qr,wa,fvec,s1)
*      if (hom .ne. 1) hom = 0
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     INITP5
*
      subroutine initp5(ld,n,nm,nn,hom,ww,wi,sigma,y)
*
      integer ld,n,nm,nn,hom,i,xtyp
      double precision ww(ld,ld),wi(ld,ld),sigma(ld,ld)
      double precision y(nn)
*
      hom = 0
*
      do 301 i = 1,nn
        read(1,101)y(i)
101     format(d23.16)
301   continue
*
      xtyp = 1
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,y)
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     APPRD
*
      subroutine apprd(ld,n,nm,nn,hom,y,d,bvbt,ctrc,ww,wi,sigma,
     &                 f10,f20,f30,temp1,temp2,temp3,qr,wa,fvec,s1)
*
* Quasi-Newton iteration for solving initial problem (matrix D)
*
* Input parameters:
* ld - leading dimension of matrices
* n,nm - dimensions of system and model
* nn - Jacobian size
* temp1,temp2,temp3 - work matrices
* f10,f20,f30 - F(0,Y(0))
* ww,wi,sigma - work matrices for point (W,U,Sigma)
* fvec,s1 - work arrays
* bvbt,ctrc,d - B V B^t, C^t R C, D
* qr,wa - work matrix and array, used for quasi-Newton iteration
* y - starting point in vector form
*
* Output parameters:
* y - final point in vector form
* hom - parameter indicating which homotopy map will be used, depends
*       on the result of quasi-Newton iteration
*
      external fcn
*
      integer ld,n,nm,nn,hom,i,ind,job,lwa,ldfjac,xtyp
      double precision d(ld,ld),bvbt(ld,ld),ctrc(ld,ld)
      double precision f10(ld,ld),f20(ld,ld),f30(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld),temp3(ld,ld)
      double precision ww(ld,ld),wi(ld,ld),sigma(ld,ld)
      double precision qr(nn,nn),wa(nn*(n+13)/2)
      double precision y(nn),fvec(nn),s1(ld)
      double precision eps
*
      ldfjac = nn
      lwa = nn*(nn+13)/2
      hom = 0
      eps = 1.d-5
*
      call f0s(ld,n,nm,ww,wi,sigma,f10,f20,f30,d,bvbt,ctrc,
     &         temp1,temp2,temp3)
*
* Transfer point from matrix to vector form
*
      xtyp = 2
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,y)
*
      write(2,201)
201   format(/'apprd y0')
      call writev(y,nn)
*
* Perform quasi-Newton iteration
*
      call hybrj1(fcn,nn,y,fvec,qr,ldfjac,eps,hom,wa,lwa)
*
      write(6,202)hom
      write(2,202)hom
202   format(/'apprd hom =',i3)
*
      write(2,203)
203   format(/'apprd y')
      call writev(y,nn)
*
      call symmet(ld,n,nm,y,ww,wi,sigma)
      job = 1
      call rs(ld,nm,sigma,s1,job,temp1,temp2,temp3,ind)
*
      call mulmat(ld,ww,temp1,temp2,n,nm,nm,1)
      call scmat(ld,1.d0,temp2,ww,n,nm,1)
      call mulmat(ld,temp1,wi,temp2,nm,n,nm,2)
      call scmat(ld,1.d0,temp2,wi,nm,n,1)
*
      call setmat(ld,0.d0,sigma,nm,nm)
      do 311 i = 1,nm
        sigma(i,i) = s1(i)
311   continue
*
* Transfer point from vector to matrix form
*
      xtyp = 1
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,y)
*
      write(2,242)
242   format(/'sigma')
      call writem(ld,sigma,nm,nm)
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     FCN
*
      subroutine fcn(n2,x,fvec,fjac,ldfjac,iflag)
*
      integer i,n2,ldfjac,iflag,type,hom,z
      integer p2(10)
      double precision x(n2),fvec(n2),fjac(ldfjac,n2)
      double precision aa(1),p1(10000)
      double precision lambda
*
      double precision a(20,20),bvbt(20,20),ctrc(20,20),d(20,20)
      integer n,nm,m,l,ld
      common /syste/ a,bvbt,ctrc,d
      common /int/ n,nm,m,l,ld
*
      lambda = 0.d0
      type = 2
      hom = 0
      p2(1) = ld
      p2(2) = n
      p2(3) = nm
      p2(4) = type
      p2(5) = hom
*
      z = ld * ld
      call col2x(ld,ld,ld,a,p1(1))
      call col2x(ld,ld,ld,d,p1(z+1))
      call col2x(ld,ld,ld,bvbt,p1(2*z+1))
      call col2x(ld,ld,ld,ctrc,p1(3*z+1))
*
      if (iflag .eq. 1) call rho(aa,lambda,x,fvec,p1,p2)
*
      if (iflag .eq. 2) then
        do 331 i = 1,n
          call rhojac(aa,lambda,x,fjac(1,i),i,p1,p2)
331     continue
      endif
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     F0S
*
      subroutine f0s(ld,n,nm,ww,wi,sigma,f10,f20,f30,d,bvbt,ctrc,temp1,
     &               temp2,temp3)
*
      integer ld,n,nm,i,j
      double precision ww(ld,ld),wi(ld,ld),sigma(ld,ld)
      double precision f10(ld,ld),f20(ld,ld),f30(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld),temp3(ld,ld)
      double precision d(ld,ld),bvbt(ld,ld),ctrc(ld,ld)
      double precision fn1
*
*     F1(0)
*
      call mulmat(ld,wi,d,temp1,nm,n,n,1)
      call mulmat(ld,temp1,ww,temp2,nm,nm,n,1)
      call mulmat(ld,temp2,sigma,temp1,nm,nm,nm,1)
      call mulmat(ld,temp1,ww,temp3,nm,n,nm,3)
*
      call mulmat(ld,sigma,ww,temp1,nm,n,nm,3)
      call mulmat(ld,temp1,d,temp2,nm,n,n,3)
      call addmat(ld,temp2,temp3,temp3,nm,n,1)
*
      call mulmat(ld,wi,bvbt,temp1,nm,n,n,1)
      call addmat(ld,temp1,temp3,temp3,nm,n,1)
*
      call scmat(ld,1.d0,temp3,f10,nm,n)
*
*     F2(0)
*
      call mulmat(ld,wi,sigma,temp1,n,nm,nm,2)
      call mulmat(ld,temp1,wi,temp2,n,n,nm,1)
      call mulmat(ld,temp2,d,temp1,n,n,n,1)
      call mulmat(ld,temp1,ww,temp3,n,nm,n,1)
*
      call mulmat(ld,d,wi,temp1,n,nm,n,4)
      call mulmat(ld,temp1,sigma,temp2,n,nm,nm,1)
      call addmat(ld,temp2,temp3,temp3,n,nm,1)
*
      call mulmat(ld,ctrc,ww,temp1,n,nm,n,1)
      call addmat(ld,temp1,temp3,temp3,n,nm,1)
*
      call scmat(ld,1.d0,temp3,f20,n,nm)
*
*     F3(0)
*
      call mulmat(ld,wi,ww,f30,nm,nm,n,1)
      do 331 i = 1,nm
        f30(i,i) = f30(i,i) - 1.d0
331   continue
*
*
      fn1 = 0.d0
      do 351 i = 1,nm
        do 352 j = 1,n
          fn1 = fn1 + dabs(f10(i,j))
352     continue
351   continue
      fn1 = fn1 / dble(n*nm)
      write(2,251)fn1
      write(6,251)fn1
251   format(/'f10 average =',d9.2)
      fn1 = 0.d0
      do 353 i = 1,n
        do 354 j = 1,nm
          fn1 = fn1 + dabs(f20(i,j))
354     continue
353   continue
      fn1 = fn1 / dble(n*nm)
      write(2,253)fn1
      write(6,253)fn1
253   format('f20 average =',d9.2)
      fn1 = 0.d0
      do 355 i = 1,nm
        do 356 j = 1,nm
          fn1 = fn1 + dabs(f30(i,j))
356     continue
355   continue
      fn1 = fn1 / dble(nm*nm)
      write(2,255)fn1
      write(6,255)fn1
255   format('f30 average =',d9.2)
*
      return
      end
*
*-----------------------------------------------------------------------
*-----------------------------------------------------------------------
*
*     SETD
*
      subroutine setd(ld,n,trace,c1,c2,a,d,temp1,temp2)
*
      integer ld,n,trace
      double precision a(ld,ld),d(ld,ld),temp1(ld,ld),temp2(ld,ld)
      double precision c1,c2
*
      call setmat(ld,0.d0,d,n,n)
      do 301 i = 1,n
        d(i,i) = c1 * -1.d0
301   continue
      call scmat(ld,1.d0,d,temp1,n,n)
      call scmat(ld,c2,a,temp2,n,n)
      call addmat(ld,temp1,temp2,d,n,n,1)
*
      if (trace .ne. 0) then
        write(trace,213)
213     format(/'D')
        call writem(ld,d,n,n)
      endif
*
      return
      end
*
