      subroutine shrslv(a,b,c,m,n,na,nb,nc)
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      common /slvblk/ t(5,5),p(5),nsys
*
      integer m,n,na,nb,nc,k,km1,dk,kk,l,lm1,dl,ll,i,ib,j,ja,nsys
      double precision a(na,1),b(nb,1),c(nc,1),t,p
*
      l = 1
*
10    continue
      lm1 = l - 1
      dl = 1
      if (l .eq. n) goto 15
      if (b(l+1,l) .ne. .0) dl = 2
*
15    continue
      ll = l + dl - 1
      if (l .eq. 1) goto 30
      do 20 j = l,ll
        do 20 i = 1,m
          do 20 ib = 1,lm1
            c(i,j) = c(i,j) - c(i,ib) * b(ib,j)
20    continue
*
30    continue
      k = 1
*
40    continue
      km1 = k - 1
      dk = 1
      if (k .eq. m) goto 45
      if (a(k,k+1) .ne. .0) dk = 2
*
45    continue
      kk = k + dk - 1
      if (k .eq. 1) goto 60
      do 50 i = k,kk
        do 50 j = l,ll
          do 50 ja = 1,km1
            c(i,j) = c(i,j) - a(i,ja) * c(ja,j)
50    continue
*
60    continue
      if (dl .eq. 2) goto 80
      if (dk .eq. 2) goto 70
      t(1,1) = a(k,k) + b(l,l)
      if (t(1,1) .eq. .0) stop
      c(k,l) = c(k,l) / t(1,1)
      goto 100
*
70    continue
      t(1,1) = a(k,k) + b(l,l)
      t(1,2) = a(k,kk)
      t(2,1) = a(kk,k)
      t(2,2) = a(kk,kk) + b(l,l)
*
      p(1) = c(k,l)
      p(2) = c(kk,l)
      nsys = 2
      call sysslv
      c(k,l) = p(1)
      c(kk,l) = p(2)
      goto 100
*
80    continue
      if (dk .eq. 2) goto 90
      t(1,1) = a(k,k) + b(l,l)
      t(1,2) = b(ll,l)
      t(2,1) = b(l,ll)
      t(2,2) = a(k,k) + b(ll,ll)
*
      p(1) = c(k,l)
      p(2) = c(k,ll)
      nsys = 2
      call sysslv
      c(k,l) = p(1)
      c(k,ll) = p(2)
      goto 100
*
90    continue
      t(1,1) = a(k,k) + b(l,l)
      t(1,2) = a(k,kk)
      t(1,3) = b(ll,l)
      t(1,4) = .0
      t(2,1) = a(kk,k)
      t(2,2) = a(kk,kk) + b(l,l)
      t(2,3) = .0
      t(2,4) = t(1,3)
      t(3,1) = b(l,ll)
      t(3,2) = .0
      t(3,3) = a(k,k) + b(ll,ll)
      t(3,4) = t(1,2)
      t(4,1) = .0
      t(4,2) = t(3,1)
      t(4,3) = t(2,1)
      t(4,4) = a(kk,kk) + b(ll,ll)
*
      p(1) = c(k,l)
      p(2) = c(kk,l)
      p(3) = c(k,ll)
      p(4) = c(kk,ll)
      nsys = 4
      call sysslv
      c(k,l) = p(1)
      c(kk,l) = p(2)
      c(k,ll) = p(3)
      c(kk,ll) = p(4)
*
100   continue
      k = k + dk
      if (k .le. m) goto 40
*
      l = l + dl
      if (l .le. n) goto 10
*
      return
      end
