      subroutine sysslv()
*
* Code for solving Lyapunov and Sylvester equations
* Bartels and Stewart, Comm. of the ACM, vol. 15, pp. 820-826, 1972
*
      common /slvblk/ a(5,5),b(5),n
*
      integer n,nm1,n1,k,km1,i,j,kp1,intr,im1,ii,i1
      double precision a,aa,b,max,temp
*
      nm1 = n - 1
      n1 = n + 1
*
      do 80 k = 1,n
        km1 = k - 1
        if (k .eq. 1) goto 20
        do 10 i = k,n
          do 10 j = 1,km1
            a(i,k) = a(i,k) - a(i,j) * a(j,k)
10      continue
*
20      continue
        if (k .eq. n) goto 100
        kp1 = k + 1
        max = dabs(a(k,k))
        intr = k
*
        do 30 i = kp1,n
          aa = dabs(a(i,k))
          if (aa .le. max) goto 30
          max = aa
          intr = i
30      continue
*
        if (max .eq. .0) stop
        a(n1,k) = intr
        if (intr .eq. k) goto 50
*
        do 40 j = 1,n
          temp = a(k,j)
          a(k,j) = a(intr,j)
          a(intr,j) = temp
40      continue
*
50      continue
        do 80 j = kp1,n
          if (k .eq. 1) goto 70
          do 60 i = 1,km1
            a(k,j) = a(k,j) - a(k,i) * a(i,j)
60        continue
*
70        continue
          a(k,j) = a(k,j) / a(k,k)
80    continue
*
100   continue
      do 110 j = 1,nm1
        intr = a(n1,j)
        if (intr .eq. j) goto 110
        temp = b(j)
        b(j) = b(intr)
        b(intr) = temp
110   continue
*
200   continue
      b(1) = b(1) / a(1,1)
      do 220 i = 2,n
        im1 = i - 1
        do 210 j = 1,im1
          b(i) = b(i) - a(i,j) * b(j)
210     continue
        b(i) = b(i) / a(i,i)
220   continue
*
300   continue
      do 310 ii = 1,nm1
        i = nm1 - ii + 1
        i1 = i + 1
        do 310 j = i1,n
          b(i) = b(i) - a(i,j) * b(j)
310   continue
*
      return
      end
