#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#include "macro.h" 
#include "eglobal.h"

extern FILE *out;
extern void cg(), atxpxa();

void initp()
 
/* Choosing the starting point (Bm, Cm)_0 for homotopy
  Results: Bm, Cm in input normal form (change in common block) */
{ 
      int ind;
      register int i,j; 
      double eps=1.0e-26, f10av, f20av;

/* Compute B V B'  and save it in bvbt.           */
 
      mulmat1(b,v,temp1,n,m,m);
      mulmat3(temp1,b,bvbt,n,n,m);
 
/* Compute controllability Gramian Gc or Q        */
 
      trarray(a, tarray1,n,n);
      scmat(-1.00,bvbt,temp1,n,n);
      tmparray(temp1, tarray2,n,n);
#if ((AIX) || (HP))
      atxpxa(tarray1, ua, tarray2, &n, &n1, &n1, &n1,&eps,&ind);
#else
      atxpxa_(tarray1, ua, tarray2, &n, &n1, &n1, &n1,&eps,&ind);
#endif

      tmpmatrix(tarray2, qt1,n,n);
 
/* Compute C^t R C and save it in ctrc.            */
 
      mulmat2(c,r,temp1,n,l,l);
      mulmat1(temp1,c,ctrc,n,n,l);
 
/* Compute observability Gramian Go or P           */
 
      tmparray(a,tarray1,n,n);
      scmat(-1.00,ctrc,temp1,n,n);
      tmparray(temp1, tarray2,n,n);
#if ((AIX) || (HP))
      atxpxa(tarray1,ua,tarray2,&n,&n1,&n1,&n1,&eps,&ind);
#else
      atxpxa_(tarray1,ua,tarray2,&n,&n1,&n1,&n1,&eps,&ind);
#endif

      tmpmatrix(tarray2, pt1,n,n);
 
/* Compute the average of the two just solved equations */
 
      mulmat1(a,qt1,temp1,n,n,n);
      mulmat3(qt1,a,temp2,n,n,n);
      addmat1(temp1,temp2,temp3,n,n);
      addmat1(temp3,bvbt,ttemp1,n,n); 
 
      mulmat2(a,pt1,temp1,n,n,n);
      mulmat1(pt1,a,temp2,n,n,n);
      addmat1(temp1,temp2,temp3,n,n);
      addmat1(temp3,ctrc,ttemp2,n,n); 
 
      f10av  = f20av = 0.0;
      for(i=0;i<n;i++) 
        for(j=0;j<n;j++){
          f10av +=  fabs(ttemp1[i][j]);
          f20av +=  fabs(ttemp2[i][j]);
	  }
       
      if(f10av > 1.0e-3)      
        printf("A Q + A Q^t + BVB^t = %9.2E\n", f10av); 
      if(f20av > 1.0e-3)      
        printf("A^t P + P A + C^tRC = %9.2E\n", f20av);
 
/* Compute (W,U,Sigma) for given (Q,P)               */
 
     cg(n);
 
/* Compute the balanced form of (A,B,C)              */
 
      mulmat1(ttemp2,a,temp2,n,n,n);
      mulmat1(temp2,ttemp1,a,n,n,n);
      mulmat1(ttemp2,b,temp2,n,m,n);
      mulmat1(c,ttemp1,temp3,l,n,n); 
      scmat(1.0,temp2,b,n,m);
      scmat(1.0,temp3,c,l,n);  
 
/* Compute the initial conditions (A0,B0,C0) and (Am, Bm, Cm) */
 
      setmat(0.0,a0,n,n) ;
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++){
         a0[i][j] = a[i][j];
         am0[i][j] = a0[i][j];
	 }
 
      for(i=nm;i<n;i++)
        for(j=nm;j<n;j++) a0[i][j] = a[i][j];
 
      setmat(0.0,b0,n,m); 
      for(j=0;j<m;j++)
        for(i=0;i<nm;i++){
         b0[i][j] = b[i][j];
         bm0[i][j] = b0[i][j];
	 }
      
      setmat(0.0,c0,l,n); 
      for(j=0;j<nm;j++)
        for(i=0;i<l;i++){
         c0[i][j] = c[i][j];
         cm0[i][j] = c0[i][j];
	 }
 
     scmat(1.0, am0,am,nm,nm);
     scmat(1.0, bm0,bm,nm,m);
     scmat(1.0, cm0,cm,l,nm);
}
