#include <stdio.h>
#include "macro.h"
#include "eglobal.h"

extern FILE  *out;
extern void atxpxa(), riccnd();

#if ((AIX) || (HP))
void rho(double *aa,double *lambda,double *x,double *y,
#else
void rho_(double *aa,double *lambda,double *x,double *y,
#endif

	 double *p,int *ip)

/* RHO evaluates the homotopy map rho(a lambda,x) at a given point 
* Input parameters:lambda,x - input point (lambda,x)
* Output parameters: * y - evaluated function
*/
{ 
      register int i,j;
      int ind, nt4;
      double eps, lambda1;
 
      tomatrix(nm,nm,am,x); /* Transform variable x to (Am, Bm, Cm)*/
      tomatrix(nm,m,bm,x+nm*nm); 
      tomatrix(l,nm,cm,x+nm*nm+nm*m);
       
      gama = *lambda* gf + (1- *lambda)* g0;   /* gamma                  */
      gaman2 = 1/ (gama*gama);
 
      scmat(*lambda,adot,ttemp1,n,n);/*  A0 + lambda *(A- A0) in temp1 */ 
      addmat1(a0,ttemp1,temp1,n,n);

      scmat(*lambda,bdot,ttemp1,n,m);/*  B0 + lambda *(B - B0) in temp2*/
      addmat1(b0,ttemp1,temp2,n,m);
 
      scmat(*lambda,cdot,ttemp1,l,n);/*  C0 + lambda *(C - C0) in temp3*/
      addmat1(c0,ttemp1,temp3,l,n);
 
      mulmat1(temp2,v,bv,n,m,m); /*  BV, BVBm^t, and BVB^t */
      mulmat3(bv,bm,bvbmt,n,nm,m);
      mulmat3(bv,temp2,bvbt,n,n,m);
 
      mulmat1(bm,v,bmv,nm,m,m); /*  BmV, and Bm V Bm^T  */
      mulmat3(bmv,bm,bmvbmt,nm,nm,m);
 
      mulmat1(r,temp3,rc,l,n,l); /*  RC, and C^t RC      */
      mulmat2(temp3,rc,ctrc,n,n,l) ;
 
      mulmat1(r,cm,rcm,l,nm,l); /*  RCm, C^t RCm, and Cm^T R Cm */
      mulmat2(temp3,rcm,ctrcm,n,nm,l); 
      mulmat2(cm,rcm,cmtrcm,nm,nm,l);
 
      setmat(0.0,ttemp2,n,nm);
       takeblock(at,temp1,ttemp2,am,n,nt);  /* A tilde */
       trarray(at,uat,nt,nt);

       scmat(-1.0, ctrcm,ttemp2,n,nm);
       takeblock(rt,ctrc,ttemp2,cmtrcm,n,nt); /* R tilde */
       scmat(gaman2,rt,rtt,nt,nt);
       scmat(-1.0,rtt,ttemp3,nt,nt);
       tmparray(ttemp3,vat,nt,nt);

       takeblock(vt,bvbt,bvbmt,bmvbmt,n,nt); /* V tilde */
       tmparray(vt,ua,nt,nt);

/* Solve At Q + Q At'  + r^-2 Q Rt Q + Vt =0 */ 

       nt4 = nt2 + 1;
#if ((AIX) || (HP))
       riccnd(&nt12,&nt12,&nt12,&nt4,&nt,&nt2,uat,vat,ua,
#else
       riccnd_(&nt12,&nt12,&nt12,&nt4,&nt,&nt2,uat,vat,ua,
#endif

	tarray1,tarray2, er,ei,work,scale,itype,ipvl,ipvs);   
 
       tmpmatrix(ua,qt,nt,nt);
       partition(qt,qt1,qt12,qt2,n,nt);

/* Check the solution of the above equation                 */

       mulmat1(at,qt,ttemp2,nt,nt,nt);
       trans(ttemp2,ttemp3,nt,nt);
       addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
       addmat1(ttemp1,vt,ttemp2,nt,nt);
       mulmat1(qt,rtt,ttemp1,nt,nt,nt);
       mulmat1(ttemp1,qt,ttemp3,nt,nt,nt);
       addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
       
       eps = 0.0e0;
       for(i=0;i<nt;i++)for(j=0;j<nt;j++) eps += myabs(ttemp1[i][j]);
       eps /= ntt2;
       if(eps > 1.0e-9){
         printf("The Ricatti equation is %E \n",eps);
         fprintf(out,"The Ricatti equation is %E \n",eps); 
        }
  

/* Solve (At + r*r Q Rt)^t P  + P (At + r*r Q Rt) + Rt =0  */ 

       mulmat1(qt,rtt,ttemp1,nt,nt,nt); 
       addmat1(at,ttemp1,ttemp3,nt,nt);
       tmparray(ttemp3,uat,nt,nt);

       scmat(-1.0,rt,ttemp1,nt,nt);
       tmparray(ttemp1,tarray2,nt,nt);

       eps = 1.0e-26;
#if ((AIX) || (HP))
       atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
       atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif


       tmpmatrix(tarray2,pt,nt,nt);
       partition(pt,pt1,pt12,pt2,n,nt);

      mulmat2(pt12,qt12,temp1,nm,nm,n);/* Compute  Z2 */
      mulmat1(pt2,qt2,temp2,nm,nm,nm);
      addmat1(temp1,temp2,zt2,nm,nm);

      mulmat1(pt1,qt1,temp1,n,n,n);   /* compute Z1  */
      mulmat3(pt12,qt12,temp2,n,n,nm);
      addmat1(temp1,temp2,zt1,n,n);

      mulmat1(pt1,qt12,temp1,n,nm,n); /* Compute Z12 */
      mulmat1(pt12,qt2,temp2,n,nm,nm);
      addmat1(temp1,temp2,zt12,n,nm);

      mulmat2(pt12,qt1,temp1,nm,n,n); /* Compute Z21 */
      mulmat3(pt2,qt12,temp2,nm,n,nm);
      addmat1(temp1,temp2,zt21,nm,n);

      lambda1  = 1.0 - *lambda;
      addmat3(am, am0,temp1,nm,nm);
      scmat(lambda1,temp1,temp2,nm,nm);
      scmat(*lambda,zt2,temp3,nm,nm);
      addmat1(temp2,temp3,temp1,nm,nm);
      toarray(nm,nm,temp1,y); /* The homotopy H_Am */

      mulmat2(pt12,bv,temp1,nm,m,n);/* The homotopy H_Bm */ 
      mulmat1(pt2,bmv,temp2,nm,m,nm);
      addmat1(temp1,temp2,temp3,nm,m);

      scmat(*lambda,temp3,temp1,nm,m);
      addmat3(bm,bm0,temp2,nm,m);
      scmat(lambda1,temp2,temp3,nm,m);
      addmat1(temp1,temp3,temp2,nm,m);

      toarray(nm,m,temp2,y+nm*nm);
 
                                     /* The homotopy H_Cm */
      mulmat1(rcm,qt2,temp1,l,nm,nm); /* RCm Q2 */
      mulmat1(rc,qt12,temp2,l,nm,n);    /* RC Q12        */
      addmat3(temp1,temp2,ttemp1,l,nm); /* Sum of 2 terms in ttemp1*/ 

      mulmat2(zt1,qt12,temp2,n,nm,n); /* Z1^t Q12    */
      mulmat2(zt21,qt2,temp3,n,nm,nm);/* Z21^t Q2    */
      addmat1(temp2,temp3,temp1,n,nm); /* sum in temp1 */
      mulmat1(qt1,zt12,temp2,n,nm,n);  /* Q1 Z12    */
      mulmat1(qt12,zt2,temp3,n,nm,nm); /* Q12 Z2    */
      addmat1(temp2,temp3,ttemp2,n,nm);/* sum in ttemp2 */
      addmat1(temp1,ttemp2,ttemp3,n,nm);/* sum of 4 terms in ttemp3 */
      mulmat1(rc,ttemp3,temp1,l,nm,n);
      eps = -0.5 * gaman2;
      scmat(eps,temp1,ttemp2,l,nm);

      mulmat2(zt12,qt12,temp1,nm,nm,n); /* Z12^t Q12 */
      mulmat2(qt12,zt12,temp2,nm,nm,n); /* Q12^t Z12 */
      addmat1(temp1,temp2,temp3,nm,nm); /* sum in temp3 */
      mulmat1(qt2,zt2,temp1,nm,nm,nm); /* Q2 Z2   */
      mulmat2(zt2,qt2,temp2,nm, nm,nm); /* Z2^t Q2 */
      addmat1(temp1,temp2,temp4,nm,nm);/* sum in temp4 */
      addmat1(temp3,temp4,temp4,nm,nm);/* sum of 4 terms in temp4 */
      mulmat1(rcm,temp4,temp1,l,nm,nm);
      eps = -eps;
      scmat(eps,temp1,temp3,l,nm);

      addmat1(ttemp2,temp3,temp1,l,nm);

      addmat1(ttemp1,temp1,hcm,l,nm);

      scmat(*lambda,hcm,temp1,l,nm);
      addmat3(cm,cm0,temp2,l,nm);
      scmat(lambda1,temp2,temp3,l,nm);
      addmat1(temp1,temp3,temp2,l,nm);

      toarray(l,nm,temp2,y+m*nm+nm*nm);
}
