      subroutine rootg(n,iflag,relerr,abserr,y,pol,spol,w,par,ipar)
*
* ROOTG is called from modified FIXPNF for computing the final solution
* to the optimal model order reduction problem in over-parametrization
* setting.
*
* Input:
* ipar --  number of points for interpolation (less than 10)
* spol --  arc length for these points (the variable values)
* pol  --  values of polynomial at these variable points
* relerr --  ralative error 
* abserr --  absolute error 
*
* Output:
* y --  final solution
*
* working array -- w
*
      double precision abserr,aerr,d1mach,qsout,relerr,rerr,
     &   sout,u,sa,sb,qout
      integer iflag,jw,lcode,n,np1
c
c ***** array declarations. *****
c
      double precision spol(10),pol(10,33),y(n+1),w(n+1),par(1)
      integer ipar
c
c ***** end of dimensional information. *****
c
c the limit on the number of iterations allowed may be changed by
c changing the following parameter statement:
c
c
      u=d1mach(4)
      rerr=max(relerr,u)
      aerr=max(abserr,0.0d0)
      np1=n+1
c
c *****  main loop.  *****
c
c
*
* Compute the arc length  sa which satisfy that pol(sa,1)=1
*
      sa=spol(ipar-2)
      sb=spol(ipar)
      call interp(ipar,spol(1),pol(1,1),1,sout,0.0d0,qout)
      lcode=1
130   call root(sout,qsout,sa,sb,rerr,aerr,lcode)
      if (lcode .gt. 0) go to 140
      qout = 0.0d0 
      do 110 i=1,ipar
110        qout=pol(i,1)+(sout-spol(i))*qout
      qsout=qout - 1.0d0
      go to 130
140   if (lcode .gt. 2) then
        print*,'lcode',lcode
        iflag=6
        return
      endif
*
* Once sa is obtained, compute the y(1) 
*
      qout = 0.0d0
      do 111 i=1,ipar
111        qout=pol(i,1)+(sa-spol(i))*qout
      w(1)=qout
*
* Do the polynomial interpolation for the other components
*
      do 150 jw=2,np1
150      call interp(ipar,spol(1),pol(1,jw),1,sa,0.0d0,w(jw))
        do 210 jw=1,np1
210          y(jw)=w(jw)
c
c ***** end of main loop. *****
c
      iflag=1
      return
      end
