#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"


void jacam(double lambda, int k,int ll, double *y, int kk) 
/*
* JACAM -- evaluates kk-th column of Jacobian at given point
*           with respect to Ac. or w.r.t. Ac_kl 
* Input parameters: k, ll -- the index of the element of Ac
* Output parameters: y - evaluated function 
*/
{
      int ind;
      register int i,j;
      double eps = -1.0;
 
      setmat(0.0,att,nt,nt); /* Derivative of A tilde */
      att[n+k][n+ll] = 1.0;
         
      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Q^(j)*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp1,ttemp2,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rti,ttemp2,nt,nt,nt); /* Compute P^(j) */
      scmat(gaman2,ttemp2,ttemp2,nt,nt);
      addmat1(att,ttemp2,ttemp3,nt,nt);
      mulmat2(ttemp3,pt,ttemp1,nt,nt,nt);
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp2,ttemp1,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
 
/* Compute derivatives of H_Ac */

       hachat();

       j = 0;
       for(i=0;i<nc/2;i++){
          *(y+j) = ttemp3[2*i+1][2*i];
          *(y+j+1) = ttemp3[2*i+1][2*i+1];
          j += 2;
        } 
        *(y + nc -1) = ttemp3[nc-1][nc-1];
 
/* Compute derivatives of H_Bc */

        hbchat();
        toarray(nc,l,ttemp3,y+nc);
 
/* Compute derivatives of H_Cc */
/* Original terms              */ 
       if( m > 1){

        hcchat();

        k = nc + nc*l;
        for(i=1;i<m;i++)
          for(j=0;j<nc;j++){
            *(y+k) = ttemp3[i][j];    
            k++;
         }
       }
       for (i =0;i<nn;i++) y[i] = lambda * y[i];
       y[kk-2] += 1 - lambda;
} 
