#include "macro.h"
#include "eglobal.h"

extern void jaclam(), jacam(), jacbm(), jaccm();

#if ((AIX) || (HP))
void rhojac(double *aa, double *lambda,double *x,double *y,int *k,
#else
void rhojac_(double *aa, double *lambda,double *x,double *y,int *k,
#endif

       double *p,int *ip)
 
/* RHOJAC evaluates kk-th column of Jacobian at given point.
*
* Input parameters: lambda,x - input point (lambda,x)
* kk - column number
*
* Output parameters:
* y - evaluated function
*/
{ 
      int ik,jl, kk ;

/* Derivatives with respect to Amij          */

   kk = *k;
   if (kk > 1 && kk <= nc+1){ 
      if((kk - (kk/2)*2)){
          ik = kk - 2;
          jl = kk - 2;
       }
       else{
        if( kk-1 == nc){
           ik = kk - 2;
           jl = kk - 2;
         }
         else{
            ik = kk -1;
            jl = kk -2;
          }
       }
 
      jacam(*lambda, ik,jl,y, *k);
      return;
  }

/* Derivatives with respect to Bmij          */

   if (kk > 1 + nc && kk <= nc+1 + nc*l){ 
      kk -= nc + 1;
      compij(kk,m,ik,jl);
      jacbm(*lambda, ik,jl,y, *k);
      return;
    }
      
/* Derivatives with respect to Cmij          */

   if (kk > l*nc + nc + 1) {
      kk -= l*nc + nc + 1;
      compij(kk,nc,ik,jl);
      jaccm(*lambda, ik,jl,y, *k);
      return;
   }   

/* Derivatives with respect to lambda        */

   if (kk == 1) {
       jaclam(*lambda,y, x);
    }
}


