function cth21

fprintf(1,'%c','Continuous-Time H2-Optimal Example #1:')
fprintf(1,'%c \n',' ');
fprintf(1,'%c','10th-order Flexible Beam with Centralized Compensation')
fprintf(1,'%c \n',' ');
fprintf(1,'%c','From Hyland & Ricter [1990]')
fprintf(1,'%c \n',' ');

weightvec = logspace(0,-7,10);
ncvec = [2,4,6,8];
ctype = 1;
idata = [];

for i = 1:length(weightvec)

	weight = sqrt(weightvec(i));

	pstr = ['========================================================='];
	fprintf(1,'%c',pstr)
	fprintf(1,'%c \n',' ');

	pstr = ['Weight = ',num2str(weight)];
	fprintf(1,'%c',pstr)
	fprintf(1,'%c \n',' ');

	jdata = [];

	for j = 1:length(ncvec)

		load beamplant
		Dzu = Dzu*weight;

		nc = ncvec(j);

		fprintf(1,'%c \n',' ');
		fprintf(1,'%c \n',' ');

		pstr = ['Comp. Order = ',num2str(nc)];
		fprintf(1,'%c',pstr)
		fprintf(1,'%c \n',' ');

		fstr = ['DATAFILE'];
		dsofformat(fstr,nc,[1,1],A,Bu,Bw,Cy,Cz,Dyu,Dyw,Dzu,Dzw)

		loadstr = ['load ',fstr];
		eval(loadstr)
		clear loadstr

		loadstr = ['load initNC',num2str(nc),'WT',num2str(i-1)];
		eval(loadstr)
		clear loadstr
		
		rstr = ['RUNFILE'];

		savestr = ['save ',rstr,' A Bu Bw Cy Cz Dyu Dyw Dzu Dzw'];
		savestr = [savestr,' QL11 QL21 QL31 QR11 QR21 QR31 N k1 k2 k3'];
		savestr = [savestr,' ctype kindex indexkc indexkr'];
		eval(savestr)
		clear savestr

		ostr = ['OUTFILE'];

		tic
		[fmin,info,noits] = optgain(rstr,ostr);
		delt = toc;

		loadstr = ['load ',ostr];
		eval(loadstr)
		clear loadstr

		k1 = kopt1;k2 = kopt2;k3 = kopt3;

		savestr = ['save initNC',num2str(nc),'WT',num2str(i),' k1 k2 k3'];
		eval(savestr)
		clear savestr

		jdata = [jdata;weight,nc,fmin,info,noits,delt];

		save SUBOUTRUN jdata

	end

	idata = [idata;jdata];
	
	save OUTRUN idata

end
		



		

		

		
