function dth22

fprintf(1,'%c','Discrete-Time H2-Optimal Benchmark #2:')
fprintf(1,'%c \n',' ');
fprintf(1,'%c','2-Channel Decentralized Control of 16th-Order Acoustic Duct')
fprintf(1,'%c \n',' ');
fprintf(1,'%c','From Erwin, Sparks, & Bernstein [1996]')
fprintf(1,'%c \n',' ');
fprintf(1,'%c','Sampling Frequency = 1000 Hz')
fprintf(1,'%c \n',' ');

sigmavec = logspace(0,-8,50);

ncvec = [1,2,4];
ctype = -1;
idata = [];

for i = 1:length(sigmavec)

	weight = sqrt(sigmavec(i));

	pstr = ['========================================================='];
	fprintf(1,'%c',pstr)
	fprintf(1,'%c \n',' ');

	pstr = ['Sigma = ',num2str(weight)];
	fprintf(1,'%c',pstr)
	fprintf(1,'%c \n',' ');

	jdata = [];

	for j = 1:length(ncvec)

		load dtaduct16modal

		Dzu = Dzu*weight;

		nc = ncvec(j);

		fprintf(1,'%c \n',' ');
		fprintf(1,'%c \n',' ');

		pstr = ['Comp. Order = (',num2str(nc),',',num2str(nc),')'];
		fprintf(1,'%c',pstr)
		fprintf(1,'%c \n',' ');

		fstr = ['DATAFILE'];
		dsofformat(fstr,[nc;nc],[1,1;1,1],A,Bu,Bw,Cy,Cz,Dyu,Dyw,Dzu,Dzw)

		loadstr = ['load ',fstr];
		eval(loadstr)
		clear loadstr

		loadstr = ['load initNC',num2str(nc),'WT',num2str(i-1)];
		eval(loadstr)
		clear loadstr
		
		rstr = ['RUNFILE'];

		savestr = ['save ',rstr,' A Bu Bw Cy Cz Dyu Dyw Dzu Dzw'];
		savestr = [savestr,' QL1 QL2 QL3 QR1 QR2 QR3 N k1 k2 k3'];
		savestr = [savestr,' QL4 QL5 QL6 QR4 QR5 QR6 N k4 k5 k6'];
		savestr = [savestr,' ctype kindex indexkc indexkr'];
		eval(savestr)
		clear savestr

		ostr = ['OUTFILE'];

		t0 = cputime;
		[fmin,info,noits] = optgain(rstr,ostr,1,0,5000,1,1);
		delt = cputime - t0;

		loadstr = ['load ',ostr];
		eval(loadstr)
		clear loadstr

		k1 = kopt1;k2 = kopt2;k3 = kopt3;
		k4 = kopt4;k5 = kopt5;k6 = kopt6;

		savestr = ['save initNC',num2str(nc),'WT',num2str(i),' k1 k2 k3'];
		savestr = [savestr,' k4 k5 k6'];
		eval(savestr)
		clear savestr

		jdata = [jdata;weight,nc,fmin,info,noits,delt];

		save SUBOUTRUN jdata

	end

	idata = [idata;jdata];
	
	save OUTRUN idata

end
		



		

		

		
