function a=ivec(veca,r,c)

% A = ivec(Avec, r, c) 
%
% IVEC converts a (r*c x 1) vector into an (r x c) matrix using the
% algorithm defined in the Robust Fixed-Structure Toolbox manual.
%

%================================================================
%
% WRITTEN: J. Friedman & W. Wang
%          8 June 1992
%          University of Michigan
%
%================================================================

[n,m]=size(veca);
if n==1
    veca=veca';
end;
a=veca(1:r);
if c>1, 
   for i=2:c
      j=i-1;
      a=[a,veca(j*r+1:r*i)];
   end;
end;
end;
