function [k0,ctype] = setup(filename)

% function [k0,ctype] = setup(filename)
%
% SETUP saves system parameters into the file 'sourcefile.mat', and
% return the initial guess for gains in vector format.
%

       	filename=['load ',filename];
       	eval(filename);

% check for valid performance criterion and generate 
% appropriate matrices
%
	if abs(ctype) == 1
		
		RSE = 1;

       	elseif ctype == 3

        	nblk = size(blk,1);
            	cum = cumsum(blk(:,1));
            	scum = cumsum(blk(:,1).*blk(:,1));

       	else

		error('Invalid value of CTYPE')

	end

	save sourcefile

%
% write gains k(i) to vector format:
%
       for i=1:N

             index = num2str(i);

             ki = eval(['k',index]); 
             ki = vec(ki);

             if i == 1

                  k0 = ki;

             else

                  k0 = [k0;ki];

             end;

       end;

       if ctype == 3, 


            wvec = [];
            zvec = [];

            for i = 1:nblk,

               if blk(i,1) == 1,

                 wvec = [wvec; WW(cum(i),cum(i))];
                 zvec = [zvec; ZZ(cum(i),cum(i))];

               elseif blk(i,1) == 2,

                 wvec = [wvec; vec(WW(cum(i)-1:cum(i),cum(i)-1:cum(i)))];
                 zvec = [zvec; vec(ZZ(cum(i)-1:cum(i),cum(i)-1:cum(i)))];

               end,

            end

	  k0 = [k0;wvec;zvec];

	end






