function stuffprint(f, g, p, h, trip, iterate)
%===================================================================
%
% PURPOSE: To perform diagnostics
%
% WRITTEN: R. Scott Erwin
%          12 August 1993
%          University of Michigan
%
% REVISED: R. Scott Erwin
%          06 October 1993
%
%====================================================================

% debugging statements:
%
%	disp(f);
%	disp(g);
%	disp(p);
%	disp(h);
%	disp(trip);
%	disp(iterate);

        
% check to ensure full hessian has been passed on
%
	[n,n] = size(h);

	if diag(h,-1) == zeros(n-1,1) 
   
   		h = h + triu(h,1)';

	end

	H = inv(h);

	singvals = sqrt(eig(H*H'));	


% form new steps
%

	fnew = [iterate;f];
	gnew = [iterate;norm(g)];
	pnew = [iterate;norm(p)];
	hnew = [iterate;max(singvals)/min(singvals)];
 	tnew = [iterate;trip];
	anew = [iterate;acos((p'*(-1)*g)/(norm(p)*norm(g)))*180/pi];


	if iterate == 0 

		fdata = fnew;
		gdata = gnew;
		pdata = pnew;
		hdata = hnew;
		tdata = tnew;
		adata = anew;
             
	else

     	   	load funcdata.mat
		fdata = [fdata,fnew];

		load graddata.mat
		gdata = [gdata,gnew];

		load stepdata.mat
		pdata = [pdata,pnew];

		load hessdata.mat
		hdata = [hdata,hnew];

		load tripdata.mat
		tdata = [tdata,tnew];
		
		load angldata.mat
		adata = [adata,anew];

	end

	save funcdata fdata

	save graddata gdata

	save stepdata pdata

	save hessdata hdata

	save tripdata tdata

	save angldata adata


